<?php
/************************************************************************/
/* SPChat  (Multi Room Web based Chat System)                           */
/* Language file for german language                                    */
/* for phpNUKE Version 5.5 and above (http://www.phpnuke.org)           */
/* and Postnuke Version 7.2.2 and above                 */
/* ==================================================================== */
/* By Frank Wallacher (frank@saarport.net) (c) 2002-2003                */
/* http://www.saarport.net                                              */
/* ==================================================================== */
/* Based on:                                                            */
/* PHPNukeWebChat v2.0                                                  */
/* ===================                                                  */
/* Authors:                                                 */
/*                                  */
/* Frank Wallacher <frank@saarport.dyndns.org                       */
/* Web: http://www.saarport.net                                         */
/*                                  */
/* Oliver Gading   <oliver@gading.de>                   */
/* Web: http://nuke-modules.gading.de                   */
/*                                  */
/* ==================================================================== */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if (!eregi('modules.php', $GLOBALS['HTTP_SERVER_VARS']['PHP_SELF'])) die ("You can't access this file directly...");

$GLOBALS['spchat']['ModDir'] = $GLOBALS[name];

require_once('mainfile.php');
get_lang($GLOBALS['spchat']['ModDir']);
include_once('modules/'.$GLOBALS['spchat']['ModDir'].'/inc/init.inc.php');
include_once('modules/'.$GLOBALS['spchat']['ModDir'].'/inc/admin.inc.php');
include_once('modules/'.$GLOBALS['spchat']['ModDir'].'/inc/chatwindow.inc.php');
include('modules/'.$GLOBALS['spchat']['ModDir'].'/inc/functions.php');

list($status_do_upgrade,$status_do_upgrade_message) = spchat_setup_check_doupgrade();
if($GLOBALS['spchat']['configfound'] === false || $status_do_upgrade === true) {
    ver_control();
}


include('header.php');

list($dbconn) = spchat_db_getdbconn();
$pntable = spchat_db_gettables();

$myuid = spchat_sys_get_uid();


// For this to work, the admin/moderator must have joined a chat room!
// Later we need to give the co-admin/moderator an option to choose
// a room from a list.
$userdata = spchat_chatwindow_getuserdata($myuid);
    $mygid   = $userdata['gid'];



if(spchat_auth_isadmin() OR ($mygid >= 4))
{

// This is needed to skip some time consuming operations when NOT using the
// admin panel
define('__SPCHAT_ADMINPANEL_IN_USE__','yes');


// ------------------------------------------------------------------------------------------
function spchat_admin_menu() {
    print spchat_admin_disp_menu();
}

function spchat_admin_modifyconfig() {
    print spchat_admin_disp_modifyconfig();
}

function spchat_admin_modifyrooms() {
    print spchat_admin_disp_modifyrooms();
}

function spchat_admin_modifysmilies() {
    print spchat_admin_disp_modifysmilies();
}

function spchat_admin_modifysounds() {
    print spchat_admin_disp_modifysounds();
}

function spchat_admin_modifyperms() {
    print spchat_admin_disp_modifyperms();
}

function spchat_admin_viewlog() {
    if (empty($GLOBALS['startitem'])) {
        $vars['startitem'] = 1;
    } else {
        $vars['startitem'] = $GLOBALS['startitem'];
    }
    #include_once(_SPCHAT_INCLUDEPATH.'inc/helper.inc.php');
    print spchat_admin_disp_viewlog($vars);

}

function spchat_admin_updateconfig() {

    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('allowcreate'=>$GLOBALS['xallowcreate'],
                  'onlyreg'=>$GLOBALS['xonlyreg'],
                  'msg_refresh'=>$GLOBALS['xmsg_refresh'],
                  'usertime'=>$GLOBALS['xusertime'],
                  'showsmiles'=>$GLOBALS['xshowsmiles'],
                  'smilesdir'=>$GLOBALS['xsmilesdir'],
                  'usesounds'=>$GLOBALS['xusesounds'],
                  'showsounds'=>$GLOBALS['xshowsounds'],
                  'soundsdir'=>$GLOBALS['xsoundsdir'],
                  'showusers'=>$GLOBALS['xshowusers'],
                  'welcometext'=>$GLOBALS['xwelcometext'],
                  'tzone'=>$GLOBALS['xtzone'],
                  'tformat'=>$GLOBALS['xtformat'],
                  'tsformat'=>$GLOBALS['xtsformat'],
                  'makelog'=>$GLOBALS['xmakelog'],
                  'nr_lastmsgs2keep'=>$GLOBALS['xnr_lastmsgs2keep'],
                  'displaytitletable'=>$GLOBALS['xdisplaytitletable'],
                  'title'=>$GLOBALS['xtitle'],
                  'titletext'=>$GLOBALS['xtitletext'],
                  'admin_entriesperpage'=>$GLOBALS['xadmin_entriesperpage'],
                  'chatwindow_width'=>$GLOBALS['xchatwindow_width'],
                  'chatwindow_height'=>$GLOBALS['xchatwindow_height'],
                  'chatwindow_input_height'=>$GLOBALS['xchatwindow_input_height'],
                  'chatwindow_users_width'=>$GLOBALS['xchatwindow_users_width'],
                  'chatwindow_receive_height'=>$GLOBALS['xchatwindow_receive_height'],
                  'ticker1_show'=>$GLOBALS['xticker1_show'],
                  'chatwindow_ticker1_width'=>$GLOBALS['xchatwindow_ticker1_width'],
                  'ticker1_news'=>$GLOBALS['xticker1_news'],
                  'ticker2_show'=>$GLOBALS['xticker2_show'],
                  'chatwindow_ticker2_height'=>$GLOBALS['xchatwindow_ticker2_height'],
                  'ticker2_news'=>$GLOBALS['xticker2_news']);

    spchat_admin_do_updateconfig($vars);

    return;
}

function spchat_admin_updateroom() {
    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');


    $vars = array('rname'=>$GLOBALS['rname'],
                  'descript'=>$GLOBALS['descript'],
                  'typ'=>$GLOBALS['typ'],
                  'pass'=>$GLOBALS['pass'],
                  'rid'=>$GLOBALS['rid']);

    if (isset($GLOBALS['actchange']) && !empty($GLOBALS['actchange']))
    {
        spchat_admin_do_updateroom($vars);
    } elseif (isset($GLOBALS['actdelete']) && !empty($GLOBALS['actdelete']))
    {
        spchat_admin_do_deleteroom($vars);
    }
}

function spchat_admin_createroom() {
    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('rname'=>$GLOBALS['rname'],
                  'descript'=>$GLOBALS['descript'],
                  'typ'=>$GLOBALS['typ'],
                  'pass'=>$GLOBALS['pass']);
    
    spchat_admin_do_createroom($vars);

    return;
}

function spchat_admin_updatesmiley() {

    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('scode'=>$GLOBALS['scode'],
                  'sfile'=>$GLOBALS['sfile'],
                  'semotion'=>$GLOBALS['semotion'],
                  'sshowit'=>$GLOBALS['sshowit'],
                  'sid'=>$GLOBALS['sid']);

    if (isset($GLOBALS['actchange']) && !empty($GLOBALS['actchange']))
    {
        spchat_admin_do_updatesmiley($vars);
    } elseif (isset($GLOBALS['actdelete']) && !empty($GLOBALS['actdelete']))
    {
        spchat_admin_do_deletesmiley($vars);
    }

    return;
}

function spchat_admin_updatesound() {

    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('scmd'=>$GLOBALS['scmd'],
                  'sfile'=>$GLOBALS['sfile'],
                  'ssaytext'=>$GLOBALS['ssaytext'],
                  'sid'=>$GLOBALS['sid']);

    if (isset($GLOBALS['actchange']) && !empty($GLOBALS['actchange']))
    {
        spchat_admin_do_updatesound($vars);
    } elseif (isset($GLOBALS['actdelete']) && !empty($GLOBALS['actdelete']))
    {
        spchat_admin_do_deletesound($vars);
    }


    return;    

}

function spchat_admin_createsmiley() {
    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('scode'=>$GLOBALS['scode'],
                  'sfile'=>$GLOBALS['sfile'],
                  'semotion'=>$GLOBALS['semotion'],
                  'sshowit'=>$GLOBALS['sshowit']);

    spchat_admin_do_createsmiley($vars);

    return;
}

function spchat_admin_createsound() {
    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('scmd'=>$GLOBALS['scmd'],
                  'sfile'=>$GLOBALS['sfile'],
                  'ssaytext'=>$GLOBALS['ssaytext']);

    spchat_admin_do_createsound($vars);

}

function spchat_admin_deletelog() {

    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

/*
    $vars = array(''=>$GLOBALS['']);

*/
    spchat_admin_do_deletelog($vars);


    return;    

}

function spchat_admin_addmoderator() {
    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('ad_user'=>$GLOBALS['ad_user'],
                  'ad_group'=>$GLOBALS['ad_group'],
                  'ad_room'=>$GLOBALS['ad_room']);

    spchat_admin_do_addmoderator($vars);

}

function spchat_admin_delmoderator() {
    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();
    include_once(_SPCHAT_INCLUDEPATH.'inc/admin.inc.php');

    $vars = array('del_grpmemberid'=>$GLOBALS['del_grpmemberid']);

    spchat_admin_do_delmoderator($vars);

}

// ------------------------------------------------------------------------------------------

switch($func){

    case "modifyconfig":
        spchat_admin_modifyconfig();
        break;

    case "modifyrooms":
        spchat_admin_modifyrooms();
        break;

    case "modifysmilies":
        spchat_admin_modifysmilies();
        break;

    case "modifysounds":
        spchat_admin_modifysounds();
        break;

    case "modifyperms":
        spchat_admin_modifyperms();
        break;

    case "viewlog":
        spchat_admin_viewlog();
        break;

    case "viewabout":
//        spchat_admin_viewabout();
        break;

    case "updateconfig":
        spchat_admin_updateconfig();
        break;

    case "updateroom":
        spchat_admin_updateroom();
        break;

    case "createroom":
        spchat_admin_createroom();
        break;

    case "updatesmiley":
        spchat_admin_updatesmiley();
        break;

    case "updatesound":
        spchat_admin_updatesound();
        break;

    case "createsmiley":
        spchat_admin_createsmiley();
        break;

    case "createsound":
        spchat_admin_createsound();
        break;

    case "deletelog":
        spchat_admin_deletelog();
        break;
    
    case "addmoderator":
        spchat_admin_addmoderator();
    break;  

    case "delmoderator":
        spchat_admin_delmoderator();
    break;  

    default: spchat_admin_menu();
}

    }
else
    {
    print 'Not Allowed to access';
    }

include ('footer.php');

?>
