<?php

# /event new 2003-08-08 15:15
function spchat_user_event_new($vars)
{


    // 1:y,2:m:3:d,4:h,5:m
    $unixtime = mktime($vars['regs'][4],$vars['regs'][5],0,$vars['regs'][2],$vars['regs'][3],$vars['regs'][1]);

    
    
    //
    // Check whether date and time of new event would be in past
    //
    if ($unixtime <= time())
        return 'past';
        
    //
    // Check whether user has exceeded his event quota
    //
    $event = spchat_user_event_list(array('rid'=>$vars['rid'],
                                          'uid'=>$vars['uid']));

    if (sizeof($event) >= $GLOBALS['spchat']['config']['max_events_per_user'])
        return 'maxreached';



    //
    // Check whether there is already an event with same date and time in this room
    //
    $event = spchat_user_event_list(array('rid'=>$vars['rid'],
                                          'date_operator'=>'=',
                                          'datetime'=>$unixtime));
#print_r($event);
    if (!empty($event))
        return 'exists';


    
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_event_table = $pntable['spchat_event'];
    $spchat_event_column = &$pntable['spchat_event_column'];


    $sql = "INSERT INTO $spchat_event_table
               ($spchat_event_column[datetime],
                $spchat_event_column[uid],
                $spchat_event_column[rid],
                $spchat_event_column[topic],
                $spchat_event_column[created])
            VALUES (
                $unixtime,
                ".spchat_helper_prepforstore($vars['uid']).",
                ".spchat_helper_prepforstore($vars['rid']).",
                '".spchat_helper_prepforstore($vars['topic'])."',
                ".time()."
                   )";
                
#$dbconn->debug=true;
    $dbconn->Execute($sql);
#print "unixtime: $unixtime";
    return $unixtime;

    
}

function spchat_user_event_delete($vars)
{

    //
    // Check whether user has exceeded his event quota
    //
    $event = spchat_user_event_list(array('eid'=>$vars['eid']));

    if (empty($event))
        return 'notexists';

#print "mygid: $vars[gid], yourgid: $event[gid]";
    if ($vars['uid'] != $event['uid'] && $vars['gid'] <= $event['gid'])
        return 'itemnopermission';

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_event_table = $pntable['spchat_event'];
    $spchat_event_column = &$pntable['spchat_event_column'];


    $sql = "DELETE FROM $spchat_event_table
            WHERE $spchat_event_column[eid]=".spchat_helper_prepforstore($vars['eid'])."";

    $dbconn->Execute($sql);
    
    return $event;
    
}


function spchat_user_event_list($vars)
{




    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_event_table = $pntable['spchat_event'];
    $spchat_event_column = &$pntable['spchat_event_column'];

    $where_and = array();
    if (!empty($vars['eid']))
        $where_and[] = "$spchat_event_column[eid] = ".spchat_helper_prepforstore($vars['eid']);
    if (!empty($vars['uid']))
        $where_and[] = "$spchat_event_column[uid] = ".spchat_helper_prepforstore($vars['uid']);
    if (!empty($vars['rid']))
        $where_and[] = "$spchat_event_column[rid] = ".spchat_helper_prepforstore($vars['rid']);
    if (!empty($vars['date_operator']))
        $date_op = $vars['date_operator'];
    else
        $date_op = '>=';
    if (!empty($vars['datetime']))
        $where_and[] = "$spchat_event_column[datetime] $date_op ".$vars['datetime'];
    if (!empty($vars['limit']))
        $limit = "LIMIT $vars[limit]";
    else
        $limit = '';

    $where = join(' AND ',$where_and);
    
    $sql = "SELECT $spchat_event_column[eid],
                   $spchat_event_column[datetime],
                   $spchat_event_column[uid],
                   $spchat_event_column[rid],
                   $spchat_event_column[topic],
                   $spchat_event_column[created]
            FROM $spchat_event_table
            WHERE 
              $where
            ORDER BY $spchat_event_column[datetime] ASC
            $limit";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
    $events_list = array();
    if(!$result->EOF)
    {
        for(;!$result->EOF;$result->MoveNext())
        {
            list($eid, $datetime, $uid, $rid, $topic, $created) = $result->fields;

            list($chatroom,$admincreated) = spchat_chatwindow_getroomdata($rid);
            $userdata = spchat_chatwindow_getuserdata($uid);
#print "userdata: "; print_r($userdata);            
            $event = array('eid'=>$eid,
                           'datetime'=>$datetime,
                           'uid'=>$uid,
                           'uname'=>$userdata['username'],
                           'gid'=>spchat_auth_determine_gid($uid,$rid),
                           'rid'=>$rid,
                           'roomname'=>$chatroom,
                           'topic'=>$topic,
                           'created'=>$created);
#print_r($event);

            if (empty($vars['eid']))
                $events_list[$eid] = $event;
            else
                $events_list = $event;

        }
    }
    $result->Close();

    return $events_list;        
    
}

function spchat_chatwindow_fetch_sound($command)
{
// SOUND COMMANDS
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_sound_table = $pntable['spchat_sound'];
    $spchat_sound_column = &$pntable['spchat_sound_column'];
    $sql = "SELECT $spchat_sound_column[cmd],
                   $spchat_sound_column[file],
                   $spchat_sound_column[saytext]
            FROM $spchat_sound_table
            WHERE $spchat_sound_column[cmd] = '".spchat_helper_prepforstore($command)."'
            LIMIT 1";
    $result = $dbconn->Execute($sql);
    if(!$result->EOF)
    {
        list($cmd, $sndfile, $sndtext) = $result->fields;
        $result->Close();
        return array('cmd'=>$cmd,
                     'sndfile'=>$sndfile,
                     'sndtext'=>$sndtext);
    } else {
        $result->Close();
        return false;        
    }
}

function spchat_chatwindow_format_username($username,$color='',$self=false)
{
    #debug2_(__FILE__, __LINE__, "username", $username);

    if ($self === true)
        $username_new = ereg_replace('^(guest)',_NICKGUEST,$username);
    else
    {
        if ($username == '*empty*')
            $username_new = $username;
        else {
            if (!empty($color))
            {
                $colorstr_start = '<font color="'.$color.'">';
                $colorstr_end = '</font>';
            }

            $username_new = '<a title="'._NEWDEFINE_SEND_PM_TO.' '.ereg_replace('^(guest)',_NICKGUEST,$username).'. '._SPCHAT_ONLY_RCPT_CAN_READ_PM.'" href="#" onClick="sendMessage(\''.$username.'\'); return false">'.$colorstr_start.ereg_replace('^(guest)',_NICKGUEST,$username).$colorstr_end.'</a>';    

        }
    }
    return $username_new;  
    
}

/**
 * Checks whether username or ip is on kick list.
 * Returns
 *  not kicked: false
 *  kicked: true
 */
function spchat_auth_is_kicked($username,$ip='')
{

/*
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
    $spchat_user_table = $pntable['spchat_user'];
    $spchat_user_column = &$pntable['spchat_user_column'];
    $sql = "SELECT $spchat_user_column[name]
            FROM $spchat_user_table";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
    $users = array();
    for(;!$result->EOF;$result->MoveNext()) {
        list($name) = $result->fields;
        //$users[] = spchat_chatwindow_format_username($name,'',true);
        $users[] = $name;
    }
    $result->Close();

print "<pre>"; print_r($users); print "</pre>";
foreach($users AS $user) {
    if ($user == $username)
        return false;
}
#print "<pre>"; print_r($users); print "</pre>";
#return false;

*/
    // Simplify function call. Usually you won't need to give
    // the ip, since we retrieve it here.
    if (empty($ip))
        $ip = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
        
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_kicklist_table = $pntable['spchat_kicklist'];
    $spchat_kicklist_column = &$pntable['spchat_kicklist_column'];
    $sql = "SELECT $spchat_kicklist_column[name], $spchat_kicklist_column[ip]
            FROM $spchat_kicklist_table
            WHERE $spchat_kicklist_column[name]='$username'
               OR $spchat_kicklist_column[ip]='$ip'";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
#$dbconn->debug=false;
    if(!$result->EOF)
    {
        $result->Close();
        return true;
    } else {
#print $sql;
        $result->Close();
        return false;
    }

}

/**
 * 
 */
function spchat_sys_make_log_entry($vars)
{

    if($GLOBALS['spchat']['config']['makelog'] == 1)
    {

        include_once(_SPCHAT_INCLUDEPATH.'inc/helper.inc.php');

        if (!isset($vars['date']))
            $vars['date'] = time();

        if (!isset($vars['ip']) || !isset($vars['name']) || !isset($vars['rid']))
        {
            $uid = $GLOBALS['spchat']['user']['uid'];
            //$uid = spchat_sys_get_uid();
            $userdata = spchat_chatwindow_getuserdata($uid);

            if (!isset($vars['ip']))
                $vars['ip'] = $userdata['ip'];
            if (!isset($vars['name']))
                $vars['name'] = $userdata['username'];
            if (!isset($vars['rid']))
                $vars['rid'] = $userdata['rid'];
        }

        if (!isset($vars['rname']))
        {
            list($chatroom,$admincreated) = spchat_chatwindow_getroomdata($vars['rid']);
            $vars['rname'] = $chatroom;
        }
   
    
        list($dbconn) = spchat_db_getdbconn();
        $pntable = spchat_db_gettables();

        $spchat_log_table = $pntable['spchat_log'];
        $spchat_log_column = &$pntable['spchat_log_column'];
        $sql = "INSERT INTO $spchat_log_table
                ( $spchat_log_column[date],
                  $spchat_log_column[ip],
                  $spchat_log_column[name],
                  $spchat_log_column[rid],
                  $spchat_log_column[rname],
                  $spchat_log_column[rcpt],
                  $spchat_log_column[cmd],
                  $spchat_log_column[msg] )
                VALUES ($vars[date],'$vars[ip]', '$vars[name]', $vars[rid], '$vars[rname]', '$vars[rcpt]', '$vars[cmd]',
                  '".spchat_helper_prepforstore($vars['msg'])."')";
#                  '".$vars['msg']."')";

        $dbconn->Execute($sql);
    }
    
}

function spchat_user_update_userdetails($uid,$field,$value)
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_user_table = $pntable['spchat_user'];
    $spchat_user_column = &$pntable['spchat_user_column'];
    $sql = "UPDATE $spchat_user_table
            SET $spchat_user_column[$field] = '$value'
            WHERE $spchat_user_column[uid] = ".$uid;
    #$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
    if($result===false) {
        /* HMMM, NO ENTRY IN USER TABLE, WE EITHER LOST OUR CONNECTION FOR A WHILE OR A SECURITY PROBLEM */
        $result->Close();
        return false;
    } else {
        $result->Close();
        return true;    
    }
}


/**
 * Determines the users gid for a specific room.
 * Make use of this function before inserting new users into spchat_user
 * or updating spchat_user after room changes or new moderator assignments.
 * Returns the gid.
 */
function spchat_auth_determine_gid($uid,$rid)
{
#print "gid: uid: $uid, rid:$rid<br>";

    // This is i.e. the case, when fetching information from user
    // who isn't currently online.
    // Work-around calls to spchat_auth_determine_gid() which shouldn't have
    // been issued.
    if (!isset($rid))
        return '';

    // Security check. Don't accept $uid <= 0 (Guests)
    // (Todo: this could be replaced by an SQL update where the gid
    //  of the joined room gets set to 0)
    if ($uid <= 0)
        return $gid_new=0;

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_grpmember_table = $pntable['spchat_grpmember'];
    $spchat_grpmember_column = &$pntable['spchat_grpmember_column'];
    $sql = "SELECT $spchat_grpmember_column[gid],
                   $spchat_grpmember_column[rid]
            FROM $spchat_grpmember_table 
            WHERE $spchat_grpmember_column[uid]=$uid
              AND (    $spchat_grpmember_column[rid]=$rid
                    OR $spchat_grpmember_column[rid]=0
                  )";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);

    if (!$result->EOF)
    {
        
        $gid_for_all_rooms = false;
        $gid_for_joined_room = false;
        for(;!$result->EOF;$result->MoveNext())
        {
            list($gm_gid,$gm_rid) = $result->fields;
            if ($gm_rid == 0)
                $gid_for_all_rooms = $gm_gid;
            elseif ($gm_rid == $rid)
            {
                $gid_for_joined_room = $gm_gid;
            }
        }

        // $gid_for_joined_room has precedence over $gid_for_all_rooms!!!         
        // This makes it possible to set a default gid for a user for all
        // rooms and overwrite this default for specific rooms.
        //
        // Example 1:
        // *no setting*
        // The grpmembership defaults to $gid = 1
        if ($gid_for_all_rooms === false && $gid_for_joined_room === false)
        {
            $gid_new = 1;
        }

        //
        // Example 2:
        // $rid = 0;  $gid = 2
        // This user is Moderator in all rooms
        elseif ($gid_for_all_rooms !== false && $gid_for_joined_room === false)
        {
            $gid_new = $gid_for_all_rooms;
        }

        // Example 3:
        // $rid = 0, $gid = 5
        // $rid = 3, $gid = 1
        // This user has Admin permissions to all rooms except for rid==3
        // where he only has User permissions.
        // gid for rid 3 has precedence when joining room 3
        //
        // Example 4:
        // $rid = 0;  $gid = 2
        // $rid = 3;  $gid = 4
        // $rid = 12; $gid = 1
        // This user is Moderator in all rooms except for rid==3 and rid==12
        // gid for rid 3 or 12 has precedence when joining room 3 or 12
        else 
        // ($gid_for_joined_room !== false)
        {
            $gid_new = $gid_for_joined_room;
        }

    } else {
        $gid_new=1;
    }
    $result->Close();
    
    return $gid_new;        
}


/**
 * Delete messages from message queue.
 * When a user logs into that chat room, he cannot see
 * the deleted messages anymore.
 */
function spchat_chatwindow_delete_last_messages_of_room($rid)
{

    if (empty($rid))
        return true;

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
#$dbconn->debug=true;
    $spchat_message_table = $pntable['spchat_message'];
    $spchat_message_column = &$pntable['spchat_message_column'];
    $sql = "DELETE
            FROM $spchat_message_table
            WHERE $spchat_message_column[rid] = ".spchat_helper_prepforstore($rid);
    $result = $dbconn->Execute($sql);
#$dbconn->debug=false;

}

/**
 * Returns last messages of a room from table chat log.
 * Purpose should be to display recent messages to new users.
 */
function spchat_chatwindow_get_last_messages_of_room($rid)
{

    if (empty($rid))
        return '';

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
#$dbconn->debug=true;
    $spchat_message_table = $pntable['spchat_message'];
    $spchat_message_column = &$pntable['spchat_message_column'];
    $sql = "SELECT $spchat_message_column[time],
                   $spchat_message_column[send_name],
                   $spchat_message_column[message]
            FROM $spchat_message_table
            WHERE $spchat_message_column[rid] = $rid
              AND (   $spchat_message_column[cmd] = ''
                   OR $spchat_message_column[cmd] = 'NICK')
            ORDER BY $spchat_message_column[time] DESC
            LIMIT 0,".$GLOBALS['spchat']['config']['nr_lastmsgs2keep'];
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
    $messages = array();
    include_once(_SPCHAT_INCLUDEPATH.'inc/helper.inc.php');
    if(!$result->EOF) {
        for(;!$result->EOF;$result->MoveNext()) {
            list($time, $name, $message_array) = $result->fields;
            $message_array = unserialize($message_array);
            $message = spchat_helper_smiley(rawurldecode($message_array['txt']));
            $message_plain = $message_array['txt_plain'];
            
            $displayname = spchat_chatwindow_format_username($name);
#print $msg;
        $style_message    = 'font-family:sans-serif,Arial,Helvetica;font-size:11pt;font-weight:normal;margin-top:3px;margin-bottom:3px;margin-left:15px;margin-right:2px;text-ident:-5px;vertical-align:middle;';
    $style_timestamp  = 'color:#BABABA;font-family:sans-serif,Arial,Helvetica;font-size:11pt;font-weight:bold;';
        switch($GLOBALS['spchat']['config']['tsformat']) {
    
        case 2:
        if($GLOBALS['spchat']['config']['tf'] == 12)
            $timestamp = '<span style="'.$style_timestamp.'">'.date("d.m. h:i:sa", ($time + (doubleval($GLOBALS['spchat']['config']['tz'])) * 60 * 60)).'&nbsp;</span>';
    else
            $timestamp = '<span style="'.$style_timestamp.'">'.date("d.m. H:i:s", ($time + (doubleval($GLOBALS['spchat']['config']['tz'])) * 60 * 60)).'&nbsp;</span>';              
        break; 
        
        case 1:
        if($GLOBALS['spchat']['config']['tf'] == 12)
            $timestamp = '<span style="'.$style_timestamp.'">'.date("h:i:sa", ($time + (doubleval($GLOBALS['spchat']['config']['tz'])) * 60 * 60)).'&nbsp;</span>';
    else
            $timestamp = '<span style="'.$style_timestamp.'">'.date("H:i:s", ($time + (doubleval($GLOBALS['spchat']['config']['tz'])) * 60 * 60)).'&nbsp;</span>'; 
        
    break;                
        
        case 0:
        $timestamp = '';
    }
            $message = spchat_helper_smiley(rawurldecode($message));
            // $message = stripslashes(spchat_helper_smiley(rawurldecode($message)));
            $messages[] = '<div style="'.$style_message.'">'.$timestamp.'<font color="#5566BB"><b>'.$displayname.'&gt;</b></font>'.$message.'</div>';
#            print $message;
        }
    }
    $result->Close();
#    print "messages: "; print_r($messages);


    return join('',array_reverse($messages));
}


/**
 * Returns set of permissions related to a gid
 */
function spchat_auth_getperms_by_gid($gid)
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_access_table = $pntable['spchat_access'];
    $spchat_access_column = &$pntable['spchat_access_column'];
    $sql = "SELECT  $spchat_access_column[aid],
                    $spchat_access_column[gid],
                    $spchat_access_column[profile],
                    $spchat_access_column[can_log],
                    $spchat_access_column[can_up],
                    $spchat_access_column[can_kick],
                    $spchat_access_column[can_bann],
                    $spchat_access_column[can_addsmile],
                    $spchat_access_column[can_addsnd],
                    $spchat_access_column[can_addroom]
            FROM $spchat_access_table
            WHERE $spchat_access_column[gid] = $gid";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
    list($aid,$gid,$profile,$can_log,$can_up,$can_kick,$can_bann,$can_addsmile,
         $can_addsnd,$can_addroom) = $result->fields;
    $result->Close();
    return array('aid'=>$aid,
                 'gid'=>$gid,
                 'profile'=>$profile,
                 'can_log'=>$can_log,
                 'can_up'=>$can_up,
                 'can_kick'=>$can_kick,
                 'can_bann'=>$can_bann,
                 'can_addsmile'=>$can_addsmile,
                 'can_addsnd'=>$can_addsnd,
                 'can_addroom'=>$can_addroom);

}


function spchat_chatwindow_getthemedata()
{

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_colors_table = $pntable['spchat_colors'];
    $spchat_colors_column = &$pntable['spchat_colors_column'];

    $sql = "SELECT  $spchat_colors_column[bgcolor1],
            $spchat_colors_column[bgcolor2],
            $spchat_colors_column[bgcolor3],
            $spchat_colors_column[bgcolor4],
            $spchat_colors_column[bgcolor5],
            $spchat_colors_column[txtcolor1],
            $spchat_colors_column[txtcolor2]
        FROM $spchat_colors_table";
    $result = $dbconn->Execute($sql);
    if (!$result->EOF)
    {
        $themedata = $result->fields;
        $result->Close();
        return $themedata;
    } else {
        $result->Close();
        return false;
    }
}


function spchat_chatwindow_getuserdata($uid)
{
    if (empty($uid))
        return false;
    else
    {
        include_once(_SPCHAT_INCLUDEPATH.'inc/helper.inc.php');

        list($dbconn) = spchat_db_getdbconn();
        $pntable = spchat_db_gettables();

        $spchat_user_table = $pntable['spchat_user'];
        $spchat_user_column = &$pntable['spchat_user_column'];
        $users_table = $pntable['users'];
        $users_column = &$pntable['users_column'];
        // Can't remember why I switched to LEFT JOIN with users_table :(
        // Since guests don't work anymore with this query I ask for uid < 0 first
        if ( $uid < 0 )
        {
            // Guests
            $sql = "SELECT $spchat_user_column[name],
                           $spchat_user_column[last],
                           $spchat_user_column[rid],
                           $spchat_user_column[ip],
                           $spchat_user_column[useragent],
                           $spchat_user_column[useragent_sniff],
                           $spchat_user_column[settings],
                           $spchat_user_column[msglastcheck]
                    FROM $spchat_user_table
                    WHERE $spchat_user_column[uid]=".spchat_helper_prepforstore($uid);
        } else {
            // Members
            $sql = "SELECT $users_column[uname],
                           $spchat_user_column[last],
                           $spchat_user_column[rid],
                           $spchat_user_column[ip],
                           $spchat_user_column[useragent],
                           $spchat_user_column[useragent_sniff],
                           $spchat_user_column[settings],
                           $spchat_user_column[msglastcheck]
                    FROM $users_table LEFT JOIN $spchat_user_table ON $users_column[uid]=$spchat_user_column[uid]
                    WHERE $users_column[uid]=".spchat_helper_prepforstore($uid);
        }
#$dbconn->debug=true;
        $result=$dbconn->Execute($sql);
#$dbconn->debug=false;

        if (!$result->EOF)
        {
            list($username,$last,$rid,$ip,$useragent,$useragent_sniff,$settings,$msglastcheck) = $result->fields;

            $result->Close();
/*
print "nachsql: "; print_r (array('username'=>$username,
             'last'=>$last,
             'rid'=>$rid,
             'gid'=>spchat_auth_determine_gid($uid,$rid),
             'ip'=>$ip,
             'useragent'=>$useragent,
             'useragent_sniff'=>unserialize($useragent_sniff),
             'usersettings'=>unserialize($settings),
             'msglastcheck'=>$msglastcheck));
*/
            return array('username'=>$username,
                         'last'=>$last,
                         'rid'=>$rid,
                         'gid'=>spchat_auth_determine_gid($uid,$rid),
                         'ip'=>$ip,
                         'useragent'=>$useragent,
                         'useragent_sniff'=>unserialize($useragent_sniff),
                         'usersettings'=>unserialize($settings),
                         'msglastcheck'=>$msglastcheck);
        } else {
            $result->Close();
            return false;
        }
    }
}


function spchat_chatwindow_getuseridbyname($username)
{
    if (empty($username))
        return false;
    else
    {
        list($dbconn) = spchat_db_getdbconn();
        $pntable = spchat_db_gettables();
#$dbconn->debug=true;
        $spchat_user_table = $pntable['spchat_user'];
        $spchat_user_column = &$pntable['spchat_user_column'];
        $sql = "SELECT $spchat_user_column[uid]
                FROM $spchat_user_table
                WHERE name='".spchat_helper_prepforstore($username)."'";
        $result=$dbconn->Execute($sql);
        if (!$result->EOF)
        {
            list($uid) = $result->fields;
            $result->Close();
            return $uid;
        } else {
            $result->Close();
            return false;
        }
    }
}


function spchat_chatwindow_getuserprofile($uid)
{
    if (empty($uid))
        return false;
    else
    {
        list($dbconn) = spchat_db_getdbconn();
        $pntable = spchat_db_gettables();
#$dbconn->debug=true;
        $users_table = $pntable['users'];
        $users_column = &$pntable['users_column'];

        $sql = "SELECT  $users_column[uname],
                        $users_column[name],
                        $users_column[user_avatar],
                        $users_column[user_regdate],
                        $users_column[femail],
                        $users_column[user_intrest],
                        $users_column[user_from],
                        $users_column[user_occ],
                        $users_column[user_icq],
                        $users_column[user_aim],
                        $users_column[user_yim],
                        $users_column[user_msnm],
                        $users_column[user_sig],
                        $users_column[bio]
                FROM $users_table
                WHERE $users_column[uid]=$uid";
#$dbconn->debug=true;
        $result=$dbconn->Execute($sql);
        if (!$result->EOF)
        {
            list($uname,$name,$user_avatar,$user_regdate,$femail,$user_intrest,$user_from,$user_occ,$user_icq,$user_aim,$user_yim,$user_msnm,$user_sig,$bio) = $result->fields;
            $result->Close();
            // user_avatar: PHPNuke 6.5 work around
            return array('uname'=>$uname,
                         'name'=>$name,
                         'user_avatar'=>((empty($user_avatar)) ? ($GLOBALS['avatarpicdefault']) : ($user_avatar)),
                         'user_regdate'=>$user_regdate,
                         'femail'=>$femail,
                         'user_intrest'=>$user_intrest,
                         'user_from'=>$user_from,
                         'user_occ'=>$user_occ,
                         'user_icq'=>$user_icq,
                         'user_aim'=>$user_aim,
                         'user_yim'=>$user_yim,
                         'user_msnm'=>$user_msnm,
                         'user_sig'=>$user_sig,
                         'bio'=>$bio);
        } else {
            $result->Close();
            return false;
        }
    }
}


function spchat_chatwindow_getroomdata($rid)
{

    if (!isset($rid) || empty($rid))
        return false;
    else
    {
        list($dbconn) = spchat_db_getdbconn();
        $pntable = spchat_db_gettables();
#$dbconn->debug=true;
        $spchat_room_table = $pntable['spchat_room'];
        $spchat_room_column = &$pntable['spchat_room_column'];
        $sql = "SELECT $spchat_room_column[name],
                       $spchat_room_column[orig]
                FROM $spchat_room_table
                WHERE $spchat_room_column[rid]='$rid'";
        $result=$dbconn->Execute($sql);
        if (!$result->EOF)
        {
            list($chatroom,$orig) = $result->fields;
            $result->Close();
            $chatroom = stripslashes($chatroom);
            $admincreated = ($orig == 1)?(true):(false);
            return array($chatroom,$admincreated);
        } else {
            $result->Close();
            return false;
        }
    }
}
?>
