<?php

spchat_db_init_handler();

//
// Functions for PHPNuke only.
//


/**
 * Redirs to a URL. Fetches and passes session error message if available.
 * Works different in Postnuke.
 */
function spchat_http_redir($url)
{
    $errormsg = $GLOBALS['errorsess'];
    if (!empty($errormsg))
        $errorparam = '&errorsess='.urlencode($errormsg);
    else
        $errorparam = '';

    $statusmsg = $GLOBALS['statussess'];
    if (!empty($statusmsg))
        $statusparam = '&statussess='.urlencode($statusmsg);
    else
        $statusparam = '';

    Header('Location: '.$url.$errorparam.$statusparam);
    exit();
}


/**
 * Update SPChat version number in chat config table
 */
function spchat_sys_setspchatversion($newversion,$newsubversion)
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_config_table = $pntable['spchat_config'];
    $spchat_config_column = &$pntable['spchat_config_column'];

    $sql = "UPDATE $spchat_config_table
            SET pversion='$newversion', subversion='$newsubversion'";

    ob_start();
    //$dbconn->debug=true;
    $dbconn->Execute($sql);
    if (spchat_db_checkiferror($dbconn,$sql,_SPCHAT_UPDATETABLEFAILED) === false)
    {
        $output = ob_get_contents();
    }
    ob_end_clean();

    if (!empty($output))
    {
        print $output;
        return false;
    }

    return true;
}

/**
 * Returns nickname of guest
 */
function spchat_auth_remember_guest()
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

#print date("D M j G:i:s T Y");
#print  "<br>_cookie: cookie: "; print_r($_COOKIE[$GLOBALS['spchat']['cookiename']['nick']]); print '<br>';
#print  "<br>http: cookie: "; print_r($HTTP_COOKIE_VARS[$GLOBALS['spchat']['cookiename']['nick']]); print '<br>';
#phpinfo();
    $cookie_guestname = $_COOKIE[$GLOBALS['spchat']['cookiename']['nick']];

    if (!empty($cookie_guestname) && isset($cookie_guestname))
    {
        // Cookie says that this guest has already visited the spchat
        // of this site before.
        // Now let's have a look at the spchat user whether he still exists
        // or timed out.

        $spchat_user_table = $pntable['spchat_user'];
        $spchat_user_column = &$pntable['spchat_user_column'];
#$dbconn->debug=true;
        $sql = "SELECT $spchat_user_column[uid]
                FROM $spchat_user_table
                WHERE $spchat_user_column[uid] < 0
                  AND $spchat_user_column[name]='$cookie_guestname'";
        $result = $dbconn->Execute($sql);
        if(!$result->EOF)
        {
            // Guest seen in cookie is also found in spchat_user table
            list($uid) = $result->fields;
            $reuse_guest_nickname = true;
            // Guest's cookie gets refreshed
            $username = $cookie_guestname;
            setcookie($GLOBALS['spchat']['cookiename']['nick'],$username,$GLOBALS['spchat']['cookieguestexpire']);
#print "<br>reuse cookie: ".$GLOBALS['spchat']['cookiename']['nick'].", uid: $uid, username: $username<br>";
        } else {
            // Guest seen in cookie is not found in spchat_user table
            $reuse_guest_nickname = false;
            // Guest's cookie gets unset. Next step is to give him a new
            // nickname. This is necessary because we use HHMMSS for guest nicknames
            // which might be reused on days after. (Don't know whether all
            // browsers delete their cookies properly when cookie's expire date
            // is reached)
            #setcookie($GLOBALS['spchat']['cookiename']['nick'],'',time()-3600);
#print "<br>delete cookie: ".$GLOBALS['spchat']['cookiename']['nick'].", uid: $uid, username: $username<br>";
        }
        $result->Close();

    } else {
        $reuse_guest_nickname = false;
    }

    if ($reuse_guest_nickname === false )
    {
        $spchat_user_table = $pntable['spchat_user'];
        $spchat_user_column = &$pntable['spchat_user_column'];

        $sql = "SELECT $spchat_user_column[uid]
                FROM $spchat_user_table
                WHERE $spchat_user_column[uid] < 0
                ORDER BY $spchat_user_column[uid] ASC";
        $result = $dbconn->Execute($sql);
        if($result->EOF)
            $uid = -1;
        else {
            list($uid) = $result->fields;
            $uid = $uid - 1;
        }
        $result->Close();

        $nick = $GLOBALS['spchat']['nickguest'];
        $date = date(His);
        $username = $nick.$date;
        setcookie($GLOBALS['spchat']['cookiename']['nick'],$username,$GLOBALS['spchat']['cookieguestexpire']);
#print "new cookie: ".$GLOBALS['spchat']['cookiename']['nick'].", uid: $uid, username: $username<br>";

    }


    if ($uid === false || !isset($uid))
        return false;
    else
        return array($uid,$username);


}


/**
 * Returns uid only when guest exist in cookie AND chat user table
 */
function spchat_auth_refresh_guest()
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

#print "(refresh) cookie: ".$_COOKIE[$GLOBALS['spchat']['cookiename']['nick']] .'<br>';
    $cookie_guestname = $_COOKIE[$GLOBALS['spchat']['cookiename']['nick']];

    if (!empty($cookie_guestname) && isset($cookie_guestname))
    {
        // Cookie says that this guest has already visited the spchat
        // of this site before.
        // Now let's have a look at the spchat user whether he still exists
        // or timed out.

        $spchat_user_table = $pntable['spchat_user'];
        $spchat_user_column = &$pntable['spchat_user_column'];
#$dbconn->debug=true;
        $sql = "SELECT $spchat_user_column[uid]
                FROM $spchat_user_table
                WHERE $spchat_user_column[uid] < 0
                  AND $spchat_user_column[name]='$cookie_guestname'";
        $result = $dbconn->Execute($sql);
        if(!$result->EOF)
        {
            // Guest seen in cookie is also found in spchat_user table
            list($uid) = $result->fields;
            $reuse_guest_nickname = true;
            // Guest's cookie gets refreshed
            $username = $cookie_guestname;
            setcookie($GLOBALS['spchat']['cookiename']['nick'],$username,$GLOBALS['spchat']['cookieguestexpire']);
#print "cookie found: uid: $uid, username: $username<br>";
        }
        $result->Close();

    } else {
        // Guest is not seen in cookie
        // Todo: decide what to here
        $reuse_guest_nickname = false;
#        setcookie($GLOBALS['spchat']['cookiename']['nick'],'',time()-3600);
        $uid = -1; // PHPNuke Anonymous uid
#print "deleted cookie: uid: $uid, username: $username<br>";
    }
#print "refresh cookie: uid: $uid, $username: $username<br>";
#exit();
    if ($uid === false || !isset($uid))
        return false;
    else
        return array($uid);


}

/**
 * Returns human readable user_regdate
 */
function spchat_sys_convert_user_regdate($user_regdate)
{
    return $user_regdate;
}

/**
 * Returns name of logged in user
 */
function spchat_sys_get_username()
{

    if(is_user($GLOBALS['user']))
    {
        $userinfo = getusrinfo($GLOBALS['user']);
        if ($GLOBALS['version'] < 6.5)
            $uname = $userinfo['uname'];
        else
            $uname = $userinfo['username'];
    }

    return $uname;

}

/**
 * Returns uid of logged in user
 */
function spchat_sys_get_uid()
{
    if(is_user($GLOBALS['user']))
    {
        $userinfo = getusrinfo($GLOBALS['user']);
        if ($GLOBALS['version'] < 6.5)
            $uid = $userinfo['uid'];
        else
            $uid = $userinfo['user_id'];
    } else {
        list($uid) = spchat_auth_refresh_guest();
        if ($uid === false)
            return false;
    }

    // we need to set the uid global, because we can call this function spchat_auth_refresh_guest()
    // one time only. When invoked a second time, there might be issued a PHP error message
    // "Warning: Cannot add header information - headers already sent by .... send.php:91
    // " .... functions-postnuke-only.inc.php 164"
    // At least the function spchat_sys_make_log_entry() will be call when output to browser
    // has already started.
    $GLOBALS['spchat']['user']['uid']   = $uid;
    return $uid;
}

/**
 * Sets error message session var.
 * Overwrites existing error message!
 * On PHPNuke this var will only be used/passed by spchat_http_redir() !!!
 */
function spchat_sys_set_errormsg_sessionvar($errormsg)
{
    if (isset($errormsg) && !empty($errormsg))
        $GLOBALS['errorsess'] = $errormsg;

    return;    
}

/**
 * Sets status message session var.
 * Overwrites existing status message!
 * On PHPNuke this var will only be used/passed by spchat_http_redir() !!!
 */
function spchat_sys_set_statusmsg_sessionvar($statusmsg)
{
    if (isset($statusmsg) && !empty($statusmsg))
        $GLOBALS['statussess'] = $statusmsg;

    return;    
}

/**
 * Fetches error message from URL params
 * which must have passed by i.e. spchat_http_redir()
 * (Postnuke works completely different in this matter)
 * Take care with the length!!! URL params shouldn't exceed
 * a length of 1024 bytes (all together).
 */
function spchat_sys_geterrormsg()
{
    $errormsg = $GLOBALS['errorsess'];
    unset($GLOBALS['errorsess']);
    
    if (empty($errormsg))
        return '';
    else
        return urldecode($errormsg);
}

/**
 * Fetches status message from URL params
 * which must have passed by i.e. spchat_http_redir()
 * (Postnuke works completely different in this matter)
 * Take care with the length!!! URL params shouldn't exceed
 * a length of 1024 bytes (all together).
 */
function spchat_sys_getstatusmsg()
{
    $statusmsg = $GLOBALS['statussess'];
    unset($GLOBALS['statussess']);
    
    if (empty($statusmsg))
        return '';
    else
        return urldecode($statusmsg);
}

/**
 * Checks if current site visitor is a logged in user
 */
function spchat_auth_isuser()
{
    return is_user($GLOBALS['user']);
}


/**
 * Checks if current site visitor has admin permissions
 */
function spchat_auth_isadmin()
{
    return is_admin($GLOBALS['admin']);
}


/**
 * Loads current theme (bgcolor etc.)
 */
function spchat_sys_themeload()
{
    // Todo: write some PHPNuke specific code here when necessary
}

/**
 * Returns current language
 */
function spchat_sys_currentlang()
{
    return $GLOBALS['currentlang'];
}

/**
 * Init database handler
 */
function spchat_db_init_handler()
{

    if (!defined('_ADODB_LAYER'))
    {
        if(@file_exists('../../includes/adodb/adodb.inc.php'))  {
            include('../../includes/adodb/adodb.inc.php');
        } elseif(@file_exists('../includes/adodb/adodb.inc.php')) {
            include('../includes/adodb/adodb.inc.php');
        } elseif(@file_exists('includes/adodb/adodb.inc.php')) {
            include('includes/adodb/adodb.inc.php');
        } else {
            print 'ADODB NOT FOUND!';
            exit();
        }
    }
    
    // Connect to the database
    $GLOBALS['dbconn'] = &ADONewConnection($GLOBALS['dbtype']);
    $GLOBALS['dbconn']->Connect($GLOBALS['dbhost'],$GLOBALS['dbuname'],$GLOBALS['dbpass'],$GLOBALS['dbname']);

}

/**
 * Check on error for last SQL statement and output error message
 */
function spchat_db_checkiferror(&$dbconn,$sql,$errorsubject='',$be_verbose=true)
{
    if ($dbconn->ErrorNo() != 0) {
        if ($be_verbose === true)
            print('Database error: '.$errorsubject.'<br>  SQL error: "'.$dbconn->ErrorMsg().'"   SQL query: "'.$sql.'"' );
        return false;
    } else {
        return true;
    }

}

/**
 * Return database handle
 */
function spchat_db_getdbconn()
{
#    $GLOBALS['dbconn']->debug=true;
    return array($GLOBALS['dbconn']);
}

/**
 * Return table definitions.
 * For phpnuke this returns tables of spchat only.
 * If we need more table definitions, then this is the right place to collect them.
 */
function spchat_db_gettables()
{
    include_once(_SPCHAT_INCLUDEPATH.'inc/dbtables.inc.php');


    $pntable = spchat_db_getspchattables();

    // table definition taken from PHPNuke 6
    $authors = $GLOBALS['prefix'] . '_authors';
    $pntable['authors'] = $authors;
    
    $pntable['authors_column'] = array ('aid'             => $authors . '.aid',
                                        'name'            => $authors . '.name',
                                        'url'             => $authors . '.url',
                                        'email'           => $authors . '.email',
                                        'pwd'             => $authors . '.pwd',
                                        'counter'         => $authors . '.counter',
                                        'radminarticle'   => $authors . '.radminarticle',
                                        'radmintopic'     => $authors . '.radmintopic',
                                        'radminuser'      => $authors . '.radminuser',
                                        'radminsurvey'    => $authors . '.radminsurvey',
                                        'radminsection'   => $authors . '.radminsection',
                                        'radminlink'      => $authors . '.radminlink',
                                        'radminephem'     => $authors . '.radminephem',
                                        'radminfaq'       => $authors . '.radminfaq',
                                        'radmindownload'  => $authors . '.radmindownload',
                                        'radminreviews'   => $authors . '.radminreviews',
                                        'radminnewsletter'=> $authors . '.radminnewsletter',
                                        'radminforum'     => $authors . '.radminforum',
                                        'radmincontent'   => $authors . '.radmincontent',
                                        'radminency'      => $authors . '.radminency',
                                        'radminsuper'     => $authors . '.radminsuper',
                                        'admlanguage'     => $authors . '.admlanguage');
    
    $users = $GLOBALS['prefix'] . '_users';
    $pntable['users'] = $users;

    if ($GLOBALS['version'] < 6.5)
    {
        // PHPNuke < 6.5
        $pntable['users_column'] = array ('uid'             => $users . '.uid',
                                          'name'            => $users . '.name',
                                          'uname'           => $users . '.uname',
                                          'email'           => $users . '.email',
                                          'femail'          => $users . '.femail',
                                          'url'             => $users . '.url',
                                          'user_avatar'     => $users . '.user_avatar',
                                          'user_regdate'    => $users . '.user_regdate',
                                          'user_icq'        => $users . '.user_icq',
                                          'user_occ'        => $users . '.user_occ',
                                          'user_from'       => $users . '.user_from',
                                          'user_intrest'    => $users . '.user_intrest',
                                          'user_sig'        => $users . '.user_sig',
                                          'user_viewemail'  => $users . '.user_viewemail',
                                          'user_theme'      => $users . '.user_theme',
                                          'user_aim'        => $users . '.user_aim',
                                          'user_yim'        => $users . '.user_yim',
                                          'user_msnm'       => $users . '.user_msnm',
                                          'pass'            => $users . '.pass',
                                          'storynum'        => $users . '.storynum',
                                          'umode'           => $users . '.umode',
                                          'uorder'          => $users . '.uorder',
                                          'thold'           => $users . '.thold',
                                          'noscore'         => $users . '.noscore',
                                          'bio'             => $users . '.bio',
                                          'ublockon'        => $users . '.ublockon',
                                          'ublock'          => $users . '.ublock',
                                          'theme'           => $users . '.theme',
                                          'commentmax'      => $users . '.commentmax',
                                          'counter'         => $users . '.counter');
    } else {
        // PHPNuke >= 6.5
        $pntable['users_column'] = array ('uid'             => $users . '.user_id',
                                          'name'            => $users . '.name',
                                          'uname'           => $users . '.username',
                                          'email'           => $users . '.user_email',
                                          'femail'          => $users . '.femail',
                                          'url'             => $users . '.user_website',
                                          'user_avatar'     => $users . '.user_avatar',
                                          'user_regdate'    => $users . '.user_regdate',
                                          'user_icq'        => $users . '.user_icq',
                                          'user_occ'        => $users . '.user_occ',
                                          'user_from'       => $users . '.user_from',
                                          'user_intrest'    => $users . '.user_interests',
                                          'user_sig'        => $users . '.user_sig',
                                          'user_viewemail'  => $users . '.user_viewemail',
                                          'user_theme'      => $users . '.user_theme',
                                          'user_aim'        => $users . '.user_aim',
                                          'user_yim'        => $users . '.user_yim',
                                          'user_msnm'       => $users . '.user_msnm',
                                          'pass'            => $users . '.user_password',
                                          'storynum'        => $users . '.storynum',
                                          'umode'           => $users . '.umode',
                                          'uorder'          => $users . '.uorder',
                                          'thold'           => $users . '.thold',
                                          'noscore'         => $users . '.noscore',
                                          'bio'             => $users . '.bio',
                                          'ublockon'        => $users . '.ublockon',
                                          'ublock'          => $users . '.ublock',
                                          'theme'           => $users . '.theme',
                                          'commentmax'      => $users . '.commentmax',
                                          'counter'         => $users . '.counter');
    }
    return $pntable;
}

/**
 * Add admin user(s) to table spchat_grpmember
 * For phpnuke this adds all radminsuper to table spchat_grpmember
 */
function spchat_db_add_admin_to_grpmember($uid)
{
    global $prefix;

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_grpmember_table = $pntable['spchat_grpmember'];
    $spchat_grpmember_column = &$pntable['spchat_grpmember_column'];

    $result = $dbconn->Execute("SELECT aid FROM ".$prefix."_authors WHERE radminsuper=1");
    while(!$result->EOF) {
        $admins = $result->fields;

        $sql = "INSERT INTO $spchat_grpmember_table (
                $spchat_grpmember_column[uid],
                $spchat_grpmember_column[gid],
                $spchat_grpmember_column[rid])
                VALUES
                ($uid,5,0);";
        $dbconn->Execute($sql);
        if (spchat_db_checkiferror($dbconn,$sql,_SPCHAT_INSERTINTOTABLEFAILED) === false)
            return false;

        $result->MoveNext();
    }
    $result->Close();

}

function spchat_sys_language_exists($language)
{
    if (@file_exists('language/lang-'.spchat_helper_prepforstore($language).'.php'))
        return true;
    else
        return false;
}

function spchat_sys_set_language($newlanguage)
{
    setcookie('lang',$newlanguage,time()+31536000);
    return true;
}

/**
 *
 * Fetches names of languages available to both PHPNuke and (!) SPChat.
 * Returns an array of languages.
 *
 */
function spchat_sys_get_languages()
{
    $handle=opendir('language');
    $languageslist_nuke = array();
    while ($file = readdir($handle)) {

        if (preg_match("/^lang\-(.+)\.php/", $file, $matches)) {
            $langFound = trim($matches[1]);
            $languageslist_nuke[$langFound] = true;
        }
    }
    closedir($handle);
    // $languageslist = join(', ',$languageslist_nuke);

    $handle=opendir($GLOBALS['spchat']['basedir'].'/language');
    $languageslist_spchat = array();
    while ($file = readdir($handle)) {
        if (preg_match("/^lang\-(.+)\.php/", $file, $matches)) {
            $langFound = trim($matches[1]);
            if ($languageslist_nuke[$langFound] === true)
                $languageslist_spchat[$langFound] = true;
        }
    }
    closedir($handle);
    #foreach
    $languages = array();
    foreach ($languageslist_spchat AS $language => $bool)
    {
        $languages[] = $language;
    }

    return $languages;    
}

function spchat_theme_catch_tables()
{
    ob_start();
    OpenTable();
    $opentable = ob_get_contents();
    ob_end_clean();

    ob_start();
    CloseTable();
    $closetable = ob_get_contents();
    ob_end_clean();

    ob_start();
    OpenTable2();
    $opentable2 = ob_get_contents();
    ob_end_clean();

    ob_start();
    CloseTable2();
    $closetable2 = ob_get_contents();
    ob_end_clean();

    return array($opentable,$closetable,$opentable2,$closetable2);
}

/**
 * Set SPChat environment for PHPNuke systems
 */
function spchat_sys_getsysconfig()
{

    // $nukeurl,
    // $prefix,
    // $sitename,
    // $adminmail are already set and global

    $GLOBALS['version']   = $GLOBALS['Version_Num'];

    if ($GLOBALS['version'] < 6.5)
        $GLOBALS['avatardir'] = 'images/forum/avatar';
    else
        $GLOBALS['avatardir'] = 'modules/Forums/images/avatars';
    $GLOBALS['avatarpicdefault'] = 'blank.gif';  // bei Postnuke wohl nicht notwendig, da wohl immer gesetzt. PHPNuke 6.5 setzt per default ''

    @include('modules/'.$GLOBALS['spchat']['ModDir'].'/version.php');
    // $GLOBALS['spchat'] = array();
    $GLOBALS['spchat']['version']      = $spversion;
    $GLOBALS['spchat']['subversion']   = $subversion;
    $GLOBALS['spchat']['revision']     = $sprevision;
    // $GLOBALS['spchat']['ModDir']       = $GLOBALS['ModName'];
    $GLOBALS['spchat']['ModName']      = $GLOBALS['ModName'];
    $GLOBALS['spchat']['basedir']      = 'modules/'.$GLOBALS['spchat']['ModDir'];
    $GLOBALS['spchat']['templatedir']  = $GLOBALS['spchat']['basedir'].'/templates';
    $GLOBALS['spchat']['imagedir']     = $GLOBALS['spchat']['basedir'].'/images';
    $GLOBALS['spchat']['langimagedir'] = $GLOBALS['spchat']['basedir'].'/images/lang-'._SPCHAT_LANG_NAME;
    $GLOBALS['spchat']['cookiename']['nick']   = 'spchat_nick';
    $GLOBALS['spchat']['cookieguestexpire']   = time()+(60*60*24*2); // Guest cookies expire after 48 hours. This should be enough for incorrect time settings on the clients machine and for different time zones.
    $GLOBALS['spchat']['nickguest']   = 'guest';

    // page title
    $GLOBALS['spchat']['css']['pagetitle']    = 'title';
    // title of sections
    $GLOBALS['spchat']['css']['title']   = 'title';
    // title of columns and rows
    $GLOBALS['spchat']['css']['sub']     = 'storytitle';
    // content
    $GLOBALS['spchat']['css']['content'] = 'content';
    // small content
    $GLOBALS['spchat']['css']['tiny']    = 'tiny';

//    define('_SPCHAT_POSTNUKE_OR_ENVOLUTION_IN_USE','yes');
    define('_SPCHAT_STARTURL','modules.php?op=modload&name='.$GLOBALS['spchat']['ModDir'].'&file=index');
    define('_SPCHAT_STARTURLAMP','modules.php?op=modload&amp;name='.$GLOBALS['spchat']['ModDir'].'&amp;file=index');
    define('_SPCHAT_CHATWINDOWURLAMP','modules.php?op=modload&amp;name='.$GLOBALS['spchat']['ModDir'].'&amp;file=');
    define('_SPCHAT_CHATWINDOWURL','modules.php?op=modload&name='.$GLOBALS['spchat']['ModDir'].'&file=');
    define('_SPCHAT_ADMINURL','admin.php?module='.$GLOBALS['spchat']['ModDir'].'&amp;');
    define('_SPCHAT_ADMINURLREDIR','admin.php?module='.$GLOBALS['spchat']['ModDir'].'&');
    define('_SPCHAT_SETUPURL','modules.php?op=modload&name='.$GLOBALS['spchat']['ModDir'].'&file=setup');
    define('_SPCHAT_ADMINURLBASE','modules.php?op=modload&name='.$GLOBALS['spchat']['ModDir'].'&file=admin');


}

/**
 * Set SPChat environment for PHPNuke systems
 */
function spchat_sys_getchatconfig()
{

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
    $spchat_config_table = $pntable['spchat_config'];
    $spchat_config_column = &$pntable['spchat_config_column'];
    $sql = "SELECT $spchat_config_column[allowcreate],
                   $spchat_config_column[onlyreg],
                   $spchat_config_column[msg_refresh],
                   $spchat_config_column[usertime],
                   $spchat_config_column[showsmiles],
                   $spchat_config_column[smilesdir],
                   $spchat_config_column[usesounds],
                   $spchat_config_column[showsounds],
                   $spchat_config_column[soundsdir],
                   $spchat_config_column[showusers],
                   $spchat_config_column[welcometext],
                   $spchat_config_column[tz],
                   $spchat_config_column[tf],
                   $spchat_config_column[tsformat],
                   $spchat_config_column[makelog],
                   $spchat_config_column[nr_lastmsgs2keep],
                   $spchat_config_column[title],
                   $spchat_config_column[displaytitletable],
                   $spchat_config_column[titletext],
                   $spchat_config_column[admin_entriesperpage],
                   $spchat_config_column[chatwindow_width],
                   $spchat_config_column[chatwindow_height],
                   $spchat_config_column[chatwindow_input_height],
                   $spchat_config_column[chatwindow_users_width],
                   $spchat_config_column[chatwindow_receive_height],
                   $spchat_config_column[chatwindow_ticker1_width],
                   $spchat_config_column[ticker1_show],
                   $spchat_config_column[ticker1_news],
                   $spchat_config_column[chatwindow_ticker2_height],
                   $spchat_config_column[ticker2_show],
                   $spchat_config_column[ticker2_news],
                   $spchat_config_column[pversion],
                   $spchat_config_column[subversion]
            FROM $spchat_config_table";

    $result = $dbconn->Execute($sql);

    if (spchat_db_checkiferror($dbconn,$sql,'',false) === false)
    {
        $GLOBALS['spchat']['configfound'] = false;
        return false;
    }
    if ($result->EOF)
    {
        $GLOBALS['spchat']['configfound'] = false;
        return false;
    } else {
        $GLOBALS['spchat']['configfound'] = true;

        list($allowcreate, $onlyreg, $msg_refresh, $usertime,
             $showsmiles, $smilesdir, $usesounds, $showsounds,
             $soundsdir, $showusers, $welcometext, $tz, $tf,
             $tsformat, $makelog, $nr_lastmsgs2keep, $title, $displaytitletable,
             $titletext, $admin_entriesperpage, $chatwindow_width, $chatwindow_height,
             $chatwindow_input_height, $chatwindow_users_width, $chatwindow_receive_height,
             $chatwindow_ticker1_width, $ticker1_show, $ticker1_news,
             $chatwindow_ticker2_height, $ticker2_show, $ticker2_news, $pversion, $subversion
            ) = $result->fields;

        // Configs from database
        $GLOBALS['spchat']['config']['allowcreate'] = $allowcreate;
        $GLOBALS['spchat']['config']['onlyreg'] = $onlyreg;
        $GLOBALS['spchat']['config']['msg_refresh'] = $msg_refresh;
        $GLOBALS['spchat']['config']['usertime'] = $usertime;
        $GLOBALS['spchat']['config']['showsmiles'] = $showsmiles;
        $GLOBALS['spchat']['config']['smilesdir'] = $smilesdir;
        $GLOBALS['spchat']['config']['usesounds'] = $usesounds;
        $GLOBALS['spchat']['config']['showsounds'] = $showsounds;
        $GLOBALS['spchat']['config']['soundsdir'] = $soundsdir;
        $GLOBALS['spchat']['config']['showusers'] = $showusers;
        $GLOBALS['spchat']['config']['welcometext'] = $welcometext;
        $GLOBALS['spchat']['config']['tz'] = $tz;
        $GLOBALS['spchat']['config']['tf'] = $tf;
        $GLOBALS['spchat']['config']['tsformat'] = $tsformat;
        $GLOBALS['spchat']['config']['makelog'] = $makelog;
        $GLOBALS['spchat']['config']['nr_lastmsgs2keep'] = $nr_lastmsgs2keep;
        $GLOBALS['spchat']['config']['title'] = $title;
        $GLOBALS['spchat']['config']['displaytitletable'] = $displaytitletable;
        $GLOBALS['spchat']['config']['titletext'] = $titletext;

        $GLOBALS['spchat']['config']['admin_entriesperpage'] = $admin_entriesperpage;
        $GLOBALS['spchat']['config']['chatwindow_width'] = $chatwindow_width;
        $GLOBALS['spchat']['config']['chatwindow_height'] = $chatwindow_height;
        $GLOBALS['spchat']['config']['chatwindow_input_height'] = $chatwindow_input_height;
        $GLOBALS['spchat']['config']['chatwindow_users_width']      = $chatwindow_users_width;
        $GLOBALS['spchat']['config']['chatwindow_receive_height']   = $chatwindow_receive_height;
        $GLOBALS['spchat']['config']['ticker1_show'] = $ticker1_show;
        $GLOBALS['spchat']['config']['chatwindow_ticker1_width']      = $chatwindow_ticker1_width;
        $GLOBALS['spchat']['config']['ticker2_show'] = $ticker2_show;
        $GLOBALS['spchat']['config']['chatwindow_ticker2_height']      = $chatwindow_ticker2_height;

        //
        // Experimental events stuff:
        //
        $GLOBALS['spchat']['config']['allow_events'] = 1;
        $GLOBALS['spchat']['config']['maxevents_in_ticker2'] = 3;
        $GLOBALS['spchat']['config']['max_events_per_user'] = 5;
        $GLOBALS['spchat']['config']['event_format_in_ticker2'] = '_DATE_<br>&nbsp;&nbsp;&nbsp;&nbsp;_ROOMNAME_<br>&nbsp;&nbsp;&nbsp;&nbsp;(_USERNAME_)';
        // linux: %u, windows(and linux?): %w
        $GLOBALS['spchat']['config']['strftime_day_of_week_modifier'] = '%w';

        //
        // Experimental room stuff:
        //
        // 60secs must be enough - afterwards the room is deleted directly if no user is inside
        $GLOBALS['spchat']['config']['usercreated_rooms_deltime'] = 60;

        //
        // Experimental nickname stuff:
        //
        $GLOBALS['spchat']['config']['changing_nicknames_allowed'] = true;


        //
        // Experimental options stuff:
        //
        // Allow or deny use of dice option and images.
        $GLOBALS['spchat']['config']['allowdices'] = 1;
        // Default setting for user's chat window
        $GLOBALS['spchat']['config']['showdices'] = 1;
        // Default setting for user's chat window
        $GLOBALS['spchat']['config']['usenotify'] = 0;
        // Default setting for user's chat window
        $GLOBALS['spchat']['config']['usercol'] = '#000000';

        //
        // Experimental ticker stuff:
        //
        // Ticker 1
        //
        if (!empty($ticker1_news))
        {
            $GLOBALS['spchat']['config']['ticker1_news'] = unserialize(base64_decode($ticker1_news));
        } else {
            // If database field is empty, then fill the variable with a proper value:
            $GLOBALS['spchat']['config']['ticker1_news'] = array();
        }
        $max_number_of_ticker1_news = 15;
        // Fill up array to have 15 items
        if (sizeof($GLOBALS['spchat']['config']['ticker1_news']) < $max_number_of_ticker1_news)
        {
            for($i=sizeof($GLOBALS['spchat']['config']['ticker1_news'])+1;$i<=$max_number_of_ticker1_news;$i++)
            {
                $GLOBALS['spchat']['config']['ticker1_news'][] = array('url'=>'','text'=>'');
            }
        }

        //
        // Ticker 2
        //
        $ticker2_pausetime = 5000;
        $ticker2_slidespeed = 30;
        $GLOBALS['spchat']['config']['ticker2_pausetime'] = $ticker2_pausetime;
        $GLOBALS['spchat']['config']['ticker2_slidespeed'] = $ticker2_slidespeed;

        if (!empty($ticker2_news))
        {
            $GLOBALS['spchat']['config']['ticker2_news'] = unserialize(base64_decode($ticker2_news));
        } else {
            // If database field is empty, then fill the variable with a proper value:
            $GLOBALS['spchat']['config']['ticker2_news'] = array();
        }
        $max_number_of_ticker2_news = 15;
        // Fill up array to have 15 items
        if (sizeof($GLOBALS['spchat']['config']['ticker2_news']) < $max_number_of_ticker2_news)
        {
            for($i=sizeof($GLOBALS['spchat']['config']['ticker2_news'])+1;$i<=$max_number_of_ticker2_news;$i++)
            {
                $GLOBALS['spchat']['config']['ticker2_news'][] = array('url'=>'','target'=>'_blank','text'=>'');
            }
        }


        $GLOBALS['spchat']['config']['pversion'] = $pversion;
        $GLOBALS['spchat']['config']['subversion'] = $subversion;



    }
   

    #cookiedecode($GLOBALS['user']);
    #$username = $GLOBALS['cookie'][1];
    #if (spchat_auth_isadmin() || $username=='gadingo')
    if (spchat_auth_isadmin())
    {
        $GLOBALS['spchat']['config']['devdebug'] = false;   //true
    }
    else
        $GLOBALS['spchat']['config']['devdebug'] = false;

    return true;
}

function ver_control() {
    global $admin, $prefix, $dbconn, $spversion, $subversion;

    if(($Cversion < $spversion) OR (!file_exists("modules/".$GLOBALS['spchat']['ModDir']."/inc/config.php")))
        {
        include('header.php');
        OpenTable();
#        include("modules/$ModName/header.php");
        if(is_admin($admin))
            {
            CloseTable();
            print '<br>';
            OpenTable();
            print _ADMININFO_NOT_INSTALLED.'<br /><br /><p>'
            .     '<a href="modules.php?name=SPChat&file=setup">'._CLICK_HERE_FOR_INSTALL.'</a>';
            CloseTable();
#            include("modules/$ModName/footer.php");
            include ("footer.php");
            }
        else
            {
            print '<p align="left"><font class="'.$GLOBALS['spchat']['css']['content'].'"><strong>'._USERINFO_NOT_INSTALLED.'</strong></font></p>';
            CloseTable();
#            include("modules/$ModName/footer.php");
            include ("footer.php");
            exit;
            }
        }
}

?>