<?php

 // Helper functions

function spchat_helper_fetchuseragent()
{

    // query for existing phpSniff class
    if (!class_exists('phpSniff_core'))
        require_once(_SPCHAT_INCLUDEPATH.'inc/phpsniff-2.1.2/phpSniff.class.php');

    $sniffer_settings = array('check_cookies'=>false,
                              'default_language'=>'',
                              'allow_masquerading'=>false);
    $UA = '';
    $client = new phpSniff($UA,$sniffer_settings);
    
    $useragent = array();

    $useragent['browser_info'] = $client->property();

    return $useragent;    
}


function spchat_helper_cleaninput($var)
{
    // Get var
    global $$var;
    if (empty($var)) {
            return;
    }
    $ourvar = $$var;
    if (!isset($ourvar)) {
            return;
    }
    if (empty($ourvar))        {
            return $ourvar;
    }
    if (get_magic_quotes_gpc())        {
        $ourvar = stripslashes($ourvar);
    }
    return $ourvar;
}

function spchat_helper_prepforstore($var)
{
    if (!get_magic_quotes_runtime()) {
        $var = addslashes($var);
    }

    return $var;
}

function spchat_helper_smiley($message) {

  $patterns = array();
  $replace = array();

  list($dbconn) = spchat_db_getdbconn();
  $pntable = spchat_db_gettables();

  $spchat_smile_table = $pntable['spchat_smile'];
  $spchat_smile_column = &$pntable['spchat_smile_column'];
  $sql = "SELECT $spchat_smile_column[code],
                 $spchat_smile_column[file],
                 $spchat_smile_column[emotion],
                 LENGTH($spchat_smile_column[code]) AS length
                 FROM $spchat_smile_table
                 ORDER BY length
                 DESC";
  $dbsmiles = $dbconn->Execute($sql);
  if(!$dbsmiles->EOF) {
    for(;!$dbsmiles->EOF;$dbsmiles->MoveNext()) {
        list($code, $filename, $emotion, $length) = $dbsmiles->fields;
        $codes = explode('XXX',$code);
        foreach ($codes AS $code)
        {
            $patterns[] = '/([\n\\ \\.])'.preg_quote("$code").'/si';
            $replace[]  = ' <img src="'.$GLOBALS['spchat']['basedir'].'/'.$GLOBALS['spchat']['config']['smilesdir'].'/'.$filename.'" border="0" alt="'.$code.'" align="absmiddle">';
        }
    }
  }
  $dbsmiles->Close();
  // plus some xtra handy dandy ones
  $patterns[] = "/(http\:\/\/[^\s]+)/i";
  $patterns[] = "/(ftp\:\/\/[^\s]+)/i";
  $patterns[] = "/(mailto\:([^\s]+))/i";
  $patterns[] = "/\:b:(.+)\:b:/i";
  $patterns[] = "/\:i:(.+)\:i:/i";
  $patterns[] = "/\:u:(.+)\:u:/i";
  $replace[]  = "<a href=\"\\1\" target=\"_blank\">\\1</a>";
  $replace[]  = "<a href=\"\\1\" target=\"_blank\">\\1</a>";
  $replace[]  = "<a href=\"\\1\" target=\"_blank\">\\2</a>";
  $replace[]  = "<b>\\1</b>";
  $replace[]  = "<i>\\1</i>";
  $replace[]  = "<u>\\1</u>";


  // pad to allow for proper comparisms
  $message = ' '.$message;
  $message = preg_replace($patterns,$replace,$message);
  $message = substr($message,1);
  return($message);
}


 /**
  * Generates a html pager.
  * Taken from Postnukes pnHTML.php
  */
 function spchat_helper_pager($startitem,$total,$urltemplate,$perpage=30) {
 
     $output = '';
 
     if (empty($startitem)) {
         $startitem = 1;
     }
 
     if (empty($perpage)) {
         $perpage = 30;
     }
     // Make << and >> do paging properly
     // Display subset of pages if large number
 
     // Check that we are needed
     if ($total <= $perpage) {
         return;
     }
 
     // Show startitem link
     if ($startitem != 1) {
         $url = preg_replace('/%%/', 1, $urltemplate);
         $output = '<a href="'.$url.'">&lt;&lt;</a>';
     } else {
         $output = '<<';
     }
     $output .= ' ';
 
     // Show following items
     $pagenum = 1;
 
     for ($curnum = 1; $curnum <= $total; $curnum += $perpage)
     {
         if (($startitem < $curnum) || ($startitem > ($curnum + $perpage - 1)))
         {
             // Not on this page - show link
             $url = preg_replace('/%%/', $curnum, $urltemplate);
             $output .= '<a href="'.$url.'">'.$pagenum.'</a>';
             $output .= ' ';
         } else {
             // On this page - show text
             $output .= $pagenum.' ';
         }
         $pagenum++;
     }
     if (($curnum >= $perpage+1) && ($startitem < $curnum-$perpage)) {
         $url = preg_replace('/%%/', $curnum-$perpage, $urltemplate);
         $output .= '<a href="'.$url.'">&gt;&gt;</a>';
     } else {
         $output .= '&gt;&gt;';
     }
 
     return $output;        
 }
 
?>
