<?php

/**
 * Returns true, when nickname available for use
 * - checks for usernames of registered members
 * - checks for guests in chat rooms
 * - TODO: checks for censored names
 * - TODO: checks for valid letters
 * SQL 'LIKE' takes care of case sensitivity
 */
function spchat_user_check_for_existing_nicknames($nickname)
{
    $nickname_seems_ok = false;

    //
    // checking for usernames of registered members
    //

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $users_table = $pntable['users'];
    $users_column = &$pntable['users_column'];

    $sql = "SELECT $users_column[uid]
            FROM $users_table
            WHERE $users_column[uname] LIKE '".spchat_helper_prepforstore($nickname)."'";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
#exit();
    if (!$result->EOF)
    {
        $result->Close();
        return false;
    } else {
        $result->Close();
    }


    //
    // checks for guests in chat rooms
    //

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $spchat_user_table = $pntable['spchat_user'];
    $spchat_user_column = &$pntable['spchat_user_column'];

    $sql = "SELECT $spchat_user_column[uid]
            FROM $spchat_user_table
            WHERE $spchat_user_column[name] LIKE '".spchat_helper_prepforstore($nickname)."'";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
#exit();
    if (!$result->EOF)
    {
        $result->Close();
        return false;
    } else {
        $result->Close();
    }

    // nickname is available
    return true;

}

/**
 *
 */
function spchat_user_notify_im_clients_on_join()
{

    require_once(_SPCHAT_INCLUDEPATH.'inc/class.jabber.php');

    $username = '';

    $JABBER = new Jabber;

    $JABBER->server         = 'amessage.de';
    $JABBER->port           = 5222;
    $JABBER->username       = 'stottern-chat';
    $JABBER->password       = '';
    $JABBER->resource       = 'ClassJabberPHP';



#    $JABBER->Connect() or return array('return'=>false,
#                                       'errormsg'=>'Couldn\'t connect!');
    if (!$JABBER->Connect())
    {
        print 'Couldn\'t connect!';
        return array('return'=>false,
                     'errormsg'=>'Couldn\'t connect!');
    }


    if (!$JABBER->SendAuth())
    {
        print 'Couldn\'t authenticate!';
        return array('return'=>false,
                     'errormsg'=>'Couldn\'t authenticate!');
    }


    $JABBER->SendPresence(NULL, NULL, 'online');

    $JABBER->SendMessage('gadingo@amessage.de',
                         'normal',
                         NULL,
                         array( // body, thread... whatever
                               'body' => 'User '.$username.' joined room on ...'
                              ),
                         $payload
                        );

    $JABBER->Disconnect();

    return true;
}

/**
 *
 */
function spchat_user_add_room($vars)
{
    if($vars['rname'] != '' && $vars['descript'] != '')
    {

        include_once(_SPCHAT_INCLUDEPATH.'inc/helper.inc.php');

        list($dbconn) = spchat_db_getdbconn();
        $pntable = spchat_db_gettables();

        $spchat_room_table = $pntable['spchat_room'];
        $spchat_room_column = &$pntable['spchat_room_column'];

        $sql = "INSERT INTO $spchat_room_table
                ( $spchat_room_column[name],
                  $spchat_room_column[descript],
                  $spchat_room_column[typ],
                  $spchat_room_column[pass],
                  $spchat_room_column[orig],
                  $spchat_room_column[stamp] )
                VALUES ('".spchat_helper_prepforstore($vars['rname'])."', '".spchat_helper_prepforstore($vars['descript'])."', '$vars[typ]', '".spchat_helper_prepforstore($vars['pass'])."', 0,".time().")";
#$dbconn->debug=true;

        $dbconn->Execute($sql);
#exit();
        spchat_sys_set_statusmsg_sessionvar(_CREATED_ROOM);
        spchat_http_redir(_SPCHAT_STARTURL);
        return true;

    } else {
        spchat_sys_set_errormsg_sessionvar(_FILLOUT);
        spchat_http_redir(_SPCHAT_STARTURL);
        return false;
    }
}

/**
 * Returns HTML output of users SPChat overview screen
 */
function spchat_user_disp_index($roomid,$errmsg,$displaywhat='rooms',$openchatwindow=false) {

    $tpl_rooms = spchat_user_get_rooms();
    if ($tpl_rooms === false)
        $tpl_norooms = true;

    $tpl_spchat_roomid = $roomid;
    include_once(_SPCHAT_INCLUDEPATH.'inc/chatwindow.inc.php');
    list($tpl_spchat_roomname,$admincreated) = spchat_chatwindow_getroomdata($roomid);


    include(_SPCHAT_INCLUDEPATH.'inc/tplinit.inc.php');

    # Debug:
    # When testing the norooms scenario, following SQL statement should be useful
    # after deleting all rooms:
    # INSERT INTO nuke_chatroom VALUES (1, 'First Room', 'Your first Chat Room', 'N', '', 1, 0);

    ob_start();
    if ($openchatwindow === true) {
        include($GLOBALS['spchat']['templatedir'].'/user_jsopenchatwindow.tpl');
    }
    include($GLOBALS['spchat']['templatedir'].'/user_header.tpl');
    if ($displaywhat == 'joinroom') {
        include($GLOBALS['spchat']['templatedir'].'/user_joinroom.tpl');
    } else {
        // $displaywhat == 'rooms'
        include($GLOBALS['spchat']['templatedir'].'/user_rooms.tpl');
    }
    include($GLOBALS['spchat']['templatedir'].'/user_footer.tpl');
    $tploutput = ob_get_contents();
    ob_end_clean();

    return $tploutput;

}    // end diplay main index function



/**
 * Join a chat room
 *
 *
 */
function spchat_user_join_room($roomid,$pass,$username,$uid) {
    global $themedata, $confdata;
#print 'uid:'.$uid;
    unset($errmsg);
# $dbconn -> debug=true;

//    $GLOBALS[confdata] = $confdata;
// User Stuff
    if(!spchat_auth_isuser()) {
        // a guest logging in to the chat
#print "joining: !isuser<br>";
        list($uid,$username) = spchat_auth_remember_guest();
    }

    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
#$dbconn->debug=true;

    $spchat_room_table = $pntable['spchat_room'];
    $spchat_room_column = &$pntable['spchat_room_column'];

    $sql = "SELECT $spchat_room_column[name],
                   $spchat_room_column[typ],
                   $spchat_room_column[pass],
                   $spchat_room_column[descript]
            FROM $spchat_room_table
            WHERE $spchat_room_column[rid]=".$roomid;
    $result = $dbconn->Execute($sql);
    list($r_name,$r_typ,$r_pass,$r_descript) = $result->fields;
    $result->Close();
    if($r_typ == "P")
    {
        if(spchat_auth_isuser())
        {
            if($r_pass != "" && $pass=="")
            {
                //     array: 'display','openchatwindow','errormsg'
                return array('joinroom',false,'');
            } else if($pass != "")
            {
                if($pass != $r_pass)
                {
                    $errmsg = sprintf(_WRONGPASS,$r_name);
                    //     array: 'display','openchatwindow','errormsg'
                    return array('rooms',false,$errmsg);
                }
            }
        } else
        {
            $errmsg = sprintf(_ONLYREG, $r_name);
            //     array: 'display','openchatwindow','errormsg'
            return array('rooms',false,$errmsg);
        }
    }

    $username = strtr($username, " ", "_");             // Cover up blanks for chat so cmds will work

    
    // TODO: When IP address is not available (even after parsing all possible occurences
    // of arrays which might contain REMOTE_ADDR), we should disable the 'KICK' function, since
    // kicking users is currently IP based.
    if (isset($_SERVER["REMOTE_ADDR"]) && !empty($_SERVER["REMOTE_ADDR"]))
        $ip = $_SERVER["REMOTE_ADDR"];
    elseif (isset($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']) && !empty($GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR']))
        $ip = $GLOBALS['HTTP_SERVER_VARS']['REMOTE_ADDR'];
    elseif (isset($_ENV["REMOTE_ADDR"]) && !empty($_ENV["REMOTE_ADDR"]))
        $ip = $_ENV["REMOTE_ADDR"];
    else
        $ip = '';

        

    include_once(_SPCHAT_INCLUDEPATH.'inc/chatwindow.inc.php');

    if (spchat_auth_is_kicked($username) === true)
    {
         $errmsg = sprintf(_YOUKICKED, $username, $ip);
    } else { 
   
        $spchat_user_table = $pntable['spchat_user'];
        $spchat_user_column = &$pntable['spchat_user_column'];
        $spchat_room_table = $pntable['spchat_room'];
        $spchat_room_column = &$pntable['spchat_room_column'];
        $sql = "SELECT $spchat_user_column[name],
                       $spchat_user_column[uid],
                       $spchat_user_column[ip],
                       $spchat_room_column[name]
                FROM $spchat_user_table
                  LEFT JOIN $spchat_room_table ON ($spchat_user_column[rid] = $spchat_room_column[rid])
                WHERE $spchat_user_column[uid]=$uid";

        $result = $dbconn->Execute($sql);
        if(!$result->EOF) {
            $user_is_in_any_room = true;
            list($u_name, $u_id, $u_ip, $r_name) = $result->fields;
        } else {
            $user_is_in_any_room = false;
        }
        $result->Close();

    #print "bis hier hin $u_name, $u_id, $u_ip, $r_name";

        // CHECK IF USER IS STILL ONLINE
        $openchatwindow = false;
        if($user_is_in_any_room) {
            $errmsg = sprintf(_DOUBLELOGIN, $u_name, $r_name,$GLOBALS['spchat']['config']['usertime']);
        } else
        {

            // CHECK IF USER HAS AN ENTRY IN THE ACCESSLIST
            include_once(_SPCHAT_INCLUDEPATH.'inc/chatwindow.inc.php');
            $gid = spchat_auth_determine_gid($uid,$roomid);
#print "uid: $uid, roomid: $roomid, gid: $gid<br>";
            // INSERT USER IN ONLINEUSERS TABLE
            $spchat_user_table = $pntable['spchat_user'];
            $spchat_user_column = &$pntable['spchat_user_column'];
            $sql = "INSERT INTO $spchat_user_table
                    ($spchat_user_column[uid],
                     $spchat_user_column[name],
                     $spchat_user_column[last],
                     $spchat_user_column[rid],
                     $spchat_user_column[ip],
                     $spchat_user_column[settings]
                     )
                    VALUES ($uid, '$username', ".time().", $roomid, '$ip', '".serialize(
                        array('usesounds'=>$GLOBALS['spchat']['config']['usesounds'],
                              'usenotify'=>$GLOBALS['spchat']['config']['usenotify'],
                              'showdices'=>$GLOBALS['spchat']['config']['showdices'],
                              'usercol'=>$GLOBALS['spchat']['config']['usercol']))."')";
#$dbconn->debug=true;
            $dbconn->Execute($sql);

            
            // Store and/or read user profile data only when
            // user is a site member (which is determined
            // by checking whether the user is logged in or not)
            if (spchat_auth_isuser())
            {

                $spchat_profile_table = $pntable['spchat_profile'];
                $spchat_profile_column = &$pntable['spchat_profile_column'];
                $sql = "SELECT $spchat_profile_column[settings]
                        FROM $spchat_profile_table
                        WHERE $spchat_profile_column[uid]=$uid";

                
#$dbconn->debug=true;
                $result = $dbconn->Execute($sql);
#$dbconn->debug=false;
                if(!$result->EOF) {
                    list($settings) = $result->fields;
                    $settings = unserialize($settings);
#print "<pre>"; print_r($settings); print "</pre>";
                    //$user_is_stored_in_profilee_table = true;
                    $sql = "UPDATE $spchat_profile_table
                            SET $spchat_profile_column[lastseen] = ".time()."
                            WHERE $spchat_profile_column[uid] = ".$uid;
#$dbconn->debug=true;
                    $dbconn->Execute($sql);

                    $sql = "UPDATE $spchat_user_table
                            SET $spchat_user_column[settings] = '".serialize($settings)."'
                            WHERE $spchat_user_column[uid] = ".$uid;
                    $dbconn->Execute($sql);
#$dbconn->debug=false;

                } else {
                    //$user_is_stored_in_profile_table = false;
                    $sql = "INSERT INTO $spchat_profile_table
                            ($spchat_profile_column[uid],
                             $spchat_profile_column[settings],
                             $spchat_profile_column[lastseen]
                             )
                            VALUES ($uid,'".serialize(
                                array('usesounds'=>$GLOBALS['spchat']['config']['usesounds'],
                                      'usenotify'=>$GLOBALS['spchat']['config']['usenotify'],
                                      'usercol'=>$GLOBALS['spchat']['config']['usercol'],
                                      'showdices'=>$GLOBALS['spchat']['config']['showdices'])
                                     )."', ".time().")";
#$dbconn->debug=true;
                    $dbconn->Execute($sql);
#$dbconn->debug=false;
                }
                $result->Close();
                
            }
            
            include_once(_SPCHAT_INCLUDEPATH.'inc/helper.inc.php');
            $spchat_message_table = $pntable['spchat_message'];
            $spchat_message_column = &$pntable['spchat_message_column'];
            $sql = "INSERT INTO $spchat_message_table
                    ($spchat_message_column[time],
                     $spchat_message_column[rid],
                     $spchat_message_column[send_id],
                     $spchat_message_column[send_name],
                     $spchat_message_column[rcpt_id],
                     $spchat_message_column[cmd],
                     $spchat_message_column[message])
                    VALUES (".time().", $roomid, $uid, '".spchat_helper_prepforstore($username)."',0,'USERENTER', '')";
            $dbconn->Execute($sql);

            include_once(_SPCHAT_INCLUDEPATH.'inc/chatwindow.inc.php');
            list($chatroom,$admincreated) = spchat_chatwindow_getroomdata($roomid);


            spchat_sys_make_log_entry(array('rid'=>$roomid,
                                            'rname'=>$chatroom,
                                            'cmd'=>'USERENTER'));

            //
            // open up chatwindow
            //
            $openchatwindow = true;
        }
    }
    //     array: 'display','openchatwindow','errormsg'
#exit();
    return array('rooms',$openchatwindow,$errmsg);
}   // End function Join Room


/**
 *
 */
function spchat_user_get_rooms()
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
#$dbconn->debug=true;
    $spchat_user_table = $pntable['spchat_user'];
    $spchat_user_column = &$pntable['spchat_user_column'];
    $spchat_room_table = $pntable['spchat_room'];
    $spchat_room_column = &$pntable['spchat_room_column'];

    $sql = "SELECT $spchat_room_column[rid],
                   $spchat_room_column[name],
                   $spchat_room_column[descript],
                   $spchat_room_column[typ],
                   $spchat_room_column[pass],
                   $spchat_room_column[orig],
                   COUNT($spchat_user_column[rid]) AS numusers
            FROM $spchat_room_table
              LEFT JOIN $spchat_user_table ON ($spchat_user_column[rid] = $spchat_room_column[rid])
            GROUP BY $spchat_room_column[rid]
            ORDER BY $spchat_room_column[typ], $spchat_room_column[name]";
    $result = $dbconn->Execute($sql);
    if($result->EOF) {
        return false;
    } else {
        $rooms = array();

        for(;!$result->EOF;$result->MoveNext())
        {
            list($rid,$name,$descript,$typ,$pass,$orig,$numusers) = $result->fields;

            if(($GLOBALS['spchat']['config']['showusers'] == 1) AND
               ($numusers > 0))
            {
                $showusers = true;
                $users = join(', ',spchat_user_get_users_of_room($rid));

            } else {
                $showusers = false;
                unset($users);
            }
            $rooms[$rid] = array('rid'=>$rid,
                             'name'=>$name,
                             'descript'=>$descript,
                             'typ'=>$typ,
                             'pass'=>$pass,
                             'orig'=>$orig,
                             'numusers'=>$numusers,
                             'showusers'=>$showusers,
                             'users'=>$users);
        }

        return $rooms;
    }
}

/**
 * Returns Array of all users
 *
 * params:
 *   $include_anon
 *     Whether to include (default) Anononymous user in returned list or not
 *     to include.
 *   $orderby
 *     Examples:   $orderby='', $orderby='uname' (default), $orderby='uid'
 *   $flow
 *     'ASC' (default) or 'DESC'
 */
function spchat_user_get_users($include_anon=true,$orderby='uname',$flow='ASC')
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $users_table = $pntable['users'];
    $users_column = &$pntable['users_column'];

    if ($include_anon === false)
        $where = "WHERE $users_column[uid] > 1";

    if ($orderby == 'none' || $orderby == '')
        $orderby = '';
    else
        $orderby = "ORDER BY $users_column[$orderby] $flow";

    $sql = "SELECT $users_column[uid],
                   $users_column[uname]
            FROM $users_table
            $where
            $orderby";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
#exit();
    $users = array();
    if (!$result->EOF)
    {
        for(;!$result->EOF;$result->MoveNext()) {
            list($uid,$uname) = $result->fields;
            $users[] = array('uid'=>$uid,
                             'uname'=>$uname);
        }
        $result->Close();
        return $users;
    } else {
        $result->Close();
        return false;
    }
}


/**
 * Returns Array of users in one room
 */
function spchat_user_get_users_of_room($rid)
{
    include_once(_SPCHAT_INCLUDEPATH.'inc/chatwindow.inc.php');
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
    $spchat_user_table = $pntable['spchat_user'];
    $spchat_user_column = &$pntable['spchat_user_column'];
    $sql = "SELECT $spchat_user_column[name]
            FROM $spchat_user_table
            WHERE $spchat_user_column[rid]=$rid";
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);
    $users = array();
    for(;!$result->EOF;$result->MoveNext()) {
        list($name) = $result->fields;
        $users[] = spchat_chatwindow_format_username($name,'',true);
    }
    $result->Close();

    return $users;
}

function spchat_user_cleanup_tables_timeouts()
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    $usertime = $GLOBALS['spchat']['config']['usertime'];
    $tstamp = time();
    $tstamp -= $usertime;

#print "usertime: $usertime, tstamp: $tstamp<br>";
#$dbconn->debug=true;
    $spchat_user_table = $pntable['spchat_user'];
    $spchat_user_column = &$pntable['spchat_user_column'];
    $spchat_room_table = $pntable['spchat_room'];
    $spchat_room_column = &$pntable['spchat_room_column'];
    $spchat_message_table = $pntable['spchat_message'];
    $spchat_message_column = &$pntable['spchat_message_column'];
    $spchat_kicklist_table = $pntable['spchat_kicklist'];
    $spchat_kicklist_column = &$pntable['spchat_kicklist_column'];

    // Delete expired chat users
    $sql = "SELECT $spchat_user_column[uid],
                   $spchat_user_column[last]
            FROM $spchat_user_table
            WHERE $spchat_user_column[last] < ".$tstamp;
#$dbconn->debug=true;
    $result = $dbconn->Execute($sql);

    $num = $result->RecordCount();
    
#print "timedout: $num, aff: ".$dbconn->Affected_Rows().", tstamp: $tstamp";
    include_once(_SPCHAT_INCLUDEPATH.'inc/chatwindow.inc.php');

    if(!$result->EOF) {
        for(;!$result->EOF;$result->MoveNext()) {

            list($thisuid, $thislast) = $result->fields;
            $userdata = spchat_chatwindow_getuserdata($thisuid);
#print "<br>uid: $userdata[username], last: $thislast";

            $sql = "INSERT INTO $spchat_message_table
                    ( $spchat_message_column[time],
                      $spchat_message_column[rid],
                      $spchat_message_column[send_id],
                      $spchat_message_column[send_name],
                      $spchat_message_column[rcpt_id],
                      $spchat_message_column[cmd],
                      $spchat_message_column[message] )
                    VALUES (".time().", $userdata[rid], $thisuid, '$userdata[username]', 0, 'USERTIMEDOUT','')";

            $spchat_user_table = $pntable['spchat_user'];
            $spchat_user_column = &$pntable['spchat_user_column'];
            $sql2 = "DELETE FROM $spchat_user_table
                    WHERE $spchat_user_column[uid] = $thisuid
                      AND $spchat_user_column[name] = '$userdata[username]'
                      AND $spchat_user_column[rid] = $userdata[rid]";
            $dbconn->Execute($sql2);


#$dbconn->debug=true;
            $dbconn->Execute($sql);
#$dbconn->debug=false;
            //$dbconn->Execute("DELETE FROM $spchat_user_table WHERE $spchat_user_column[uid] = $uid");        

        }
    }
    $result->Close();



    // Delete old messages from each room seperately
/* test data:
INSERT INTO nuke_chatmessage VALUES (1047035721, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E1%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035729, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E2%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035733, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E3%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035735, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E4%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035737, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E5%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035739, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E6%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035740, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E7%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035758, 1, 0, 0, 'USERENTER', 'gading');
INSERT INTO nuke_chatmessage VALUES (1047035767, 1, 2, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E8%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035769, 1, 2, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E9%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035771, 1, 2, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E10%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035777, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E11%3C%2Ffont%3E');
INSERT INTO nuke_chatmessage VALUES (1047035780, 1, -1, 0, '', '%3Cfont%20color%3D%5C%22%23000000%5C%22%3E12%3C%2Ffont%3E');
*/

    // Iterate all rooms
    $result = $dbconn->Execute("SELECT $spchat_room_column[rid] FROM $spchat_room_table");
    for(;!$result->EOF;$result->MoveNext())
    {
        list($rid) = $result->fields;

        // We need a LIMIT to make sure to keep at least (not less!!!) the 
        // 'Number of messages shown on first join'

        // Since SQL DELETE doesn't support -1 as second paramenter to LIMIT
        // (which means like 'all the rest above offset'),
        // we need one more step before deleting.

        // The has lead to a bug where the first step gave us i.e. an offset
        // of '0' (based on $nr_lastmsgs2keep) resulting in deleting also the
        // most recent message. Nobody could see the chat postings of other people
        // but the post made themself. --> All posts were skipped in chat
        // windows of others.
        // $nr_lastmsgs2keep set to  1 or 2 could result in skipping some (!)
        // posts in the chat windows of others.
        // Thus we need to use a relative safe value for this, say 30. This
        // should also be sufficient for high traffic sites.
        $safe_offset = 30;

        // Determine the most recent message after $offset.
        // The 'time' field serves as reference for later deleting.
        $sql = "SELECT $spchat_message_column[time] FROM $spchat_message_table WHERE $spchat_message_column[rid]=$rid AND $spchat_message_column[cmd]='' ORDER BY $spchat_message_column[time] DESC LIMIT ".$safe_offset.",1";
//$dbconn->debug=true;
        $result2 = $dbconn->Execute($sql);
        if (!$result2->EOF)
        {

            list($reftime) = $result2->fields;

            // Delete entries
            // Also clean up the messages with roomid==0, which in most cases
            // are dummy messages to trigger a reload of the appropriate frame
            // i.e. CHANGEDCONFIG triggers the ticker window
            $sql = "DELETE FROM $spchat_message_table WHERE ($spchat_message_column[rid]=$rid || $spchat_message_column[rid]=0) AND $spchat_message_column[time] <= $reftime";
            $dbconn->Execute($sql);
        }
        $result2->Close();
//$dbconn->debug=false;
    }

    // Delete expired entries in kicklist table
    $dbconn->Execute("DELETE FROM $spchat_kicklist_table WHERE $spchat_kicklist_column[tstamp] < ".$tstamp);

}

function spchat_user_cleanup_usercreatedrooms()
{
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();

    // Cleaning unused usercreated rooms (we let 60 secs for the creator to enter the room)
    $deltime = time();
    $deltime -= $GLOBALS['spchat']['config']['usercreated_rooms_deltime'];

    $spchat_room_table = $pntable['spchat_room'];
    $spchat_room_column = &$pntable['spchat_room_column'];
    $result = $dbconn->Execute("SELECT $spchat_room_column[rid] FROM $spchat_room_table WHERE $spchat_room_column[orig]=0 and $spchat_room_column[stamp] < ".$deltime) or die;

#exit();
    if($dbconn->Affected_Rows() != 0) {
        while(!$result->EOF) {
            list($rid) = $result->fields;
            $spchat_user_table = $pntable['spchat_user'];
            $spchat_user_column = &$pntable['spchat_user_column'];
            $empty = $dbconn->Execute("SELECT $spchat_user_column[uid] FROM $spchat_user_table WHERE $spchat_user_column[rid] = ".$rid);
            if (spchat_db_checkiferror($dbconn,$sql,_SPCHAT_SELECTFROMTABLEFAILED) === false)
                return false;
            if($empty->EOF) {
                $dbconn->Execute("DELETE FROM $spchat_room_table WHERE $spchat_room_column[rid] = ".$rid);
                if (spchat_db_checkiferror($dbconn,$sql,_SPCHAT_DELETEFROMTABLEFAILED) === false)
                    return false;
            }
            $result->MoveNext();
        }
    }
    $result->Close();
}

?>