<?php
/************************************************************************/
/* SPChat  (Multi Room Web based Chat System)                           */
/* Language file for german language                                    */
/* for phpNUKE Version 5.5 and above (http://www.phpnuke.org)           */
/* and Postnuke Version 7.2.2 and above                 */
/* ==================================================================== */
/* By Frank Wallacher (frank@saarport.net) (c) 2002-2003                */
/* http://www.saarport.net                                              */
/* ==================================================================== */
/* Based on:                                                            */
/* PHPNukeWebChat v2.0                                                  */
/* ===================                                                  */
/* Authors:                                                 */
/*                                  */
/* Frank Wallacher <frank@saarport.dyndns.org                       */
/* Web: http://www.saarport.net                                         */
/*                                  */
/* Oliver Gading   <oliver@gading.de>                   */
/* Web: http://nuke-modules.gading.de                   */
/*                                  */
/* ==================================================================== */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

pnModAPILoad('spchat', 'user');

if (!function_exists(pnModGetVar))
{
    die ("You can't access this file directly...");
}

$modinfo = pnModGetInfo(pnModGetIDFromName('SPChat'));
$GLOBALS['spchat']['ModDir'] = $modinfo['directory'];

include_once('modules/'.$GLOBALS['spchat']['ModDir'].'/inc/init.inc.php');
#include_once( "modules/$modinfo[directory]/smarty_view.php";



/**
 * initialise block
 */
function spchat_overviewblock_init()
{
    // Security
    pnSecAddSchema('spchat:overviewblock:', 'Block title::');
}

/**
 * get information on block
 */
function spchat_overviewblock_info()
{
    // Values
    return array('text_type' => 'overview',
                 'module' => 'SPChat',
                 'text_type_long' => 'SPChat overview block',
                 'allow_multiple' => true,
                 'form_content' => false,
                 'form_refresh' => false,
                 'show_preview' => true);
}

/**
 * display block
 */
function spchat_overviewblock_display($blockinfo)
{
     // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();


    // Security check - important to do this as early as possible to avoid
    // potential security holes or just too much wasted processing.  For the
    // main function we want to check that the user has at least overview
    // privilege for some item within this component, or else they won't be
    // able to see anything and so we refuse access altogether.  The lowest
    // level of access for administration depends on the particular module, but
    // it is generally either 'overview' or 'read'
    if (!pnSecAuthAction(0, 'spchat:overviewblock:', '$blockinfo[title]::', ACCESS_READ)) {
//        $output->Text(_WHATSNEWSNOAUTH);
        return $output->GetOutput();

    }

    // Add menu to output - it helps if all of the module pages have a standard
    // menu at their head to aid in navigation
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(spchat_block_view());
    $output->SetInputMode(_PNH_PARSEINPUT);


    // Populate block info and pass to theme
    $blockinfo['content'] = $output->GetOutput();
    return themesideblock($blockinfo);
}


/**
 * modify block settings
 */
function spchat_overviewblock_modify($blockinfo)
{
    // Create output object
    $output = new pnHTML();

    // Get current content
    $vars = pnBlockVarsFromContent($blockinfo['content']);

/*
    // Defaults
    if (empty($vars['numitems'])) {
        $vars['numitems'] = 5;
    }
*/
    // Create row
    $row = array();
/*
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->FormText('numitems',
                               pnVarPrepForDisplay($vars['numitems']),
                               5,
                               5);
*/
    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    // Add row
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return output
    return $output->GetOutput();
}

/**
 * update block settings
 */
function spchat_overviewblock_update($blockinfo)
{
//    $vars['numitems'] = pnVarCleanFromInput('numitems');

    $blockinfo['content'] = pnBlockVarsToContent($vars);

    return $blockinfo;
}

function spchat_block_view()
{


    #pnModLoad( 'spchat' );

    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'spchat::', '::', ACCESS_OVERVIEW)) {
        $output->Text('permission denied');
        return $output->GetOutput();
    }

#    if (!pnModAPILoad('spchat', 'user')) {
#        $output->Text(_LOADFAILED);
#        return $output->GetOutput();
#    }

    pnModAPIFunc('spchat',
                 'user',
                 'cleanup_tables_timeouts');
    pnModAPIFunc('spchat',
                 'user',
                 'cleanup_usercreatedrooms');

    $rooms = pnModAPIFunc('spchat',
                          'user',
                          'get_rooms');


    $title = "Chatblock";
        $content  = '<table width="95%" align="center" cellpadding="1">';
        $content .= '<tr width="100%" align="center">';
        $content .= '<td class="content" width="100%">'._ROOM_NAME.'</td><td class="content" width="100%">'._ONLINE.'</td>';

    if ($rooms === false) {
            $content .= '<td>'.NO_ROOMS.'</td>'; 
        return $output->GetOutput();
    } else {
        foreach ($rooms AS $room) {
            $content .= '</tr><tr width="100%">';
            if($room['typ'] == "P") {
                $content .= '<td bgcolor="'.$GLOBALS[bgcolor1].'" class="content" width="100%"><img src="'.$GLOBALS['spchat']['imagedir'].'/pass.gif" alt="'._PRIVAT.'" align="middle">&nbsp;<a href="'._SPCHAT_STARTURL.'&roomid='.$room['rid'].'">'.$room['name'].'</a></td><td bgcolor="'.$GLOBALS[bgcolor1].'" class="content" width="100%" align="center">'.$room['numusers'].'</td>';
            } else {
                $content .= '<td bgcolor="'.$GLOBALS[bgcolor1].'" class="content" width="100%"><a href="'._SPCHAT_STARTURL.'&roomid='.$room['rid'].'">'.$room['name'].'</a></td><td bgcolor="'.$GLOBALS[bgcolor1].'" class="content" width="100%" align="center">'.$room['numusers'].'</td>';
            }
            $content .= '</tr><td></td>';
        }
    }
        
    $content .= '</tr>';
    $content .= '</table>';
    $content .= '<br>';
    $content .= '<center>[ <a href="'._SPCHAT_STARTURL.'">SPChat</a> ]</center>';

    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text($content);
    $output->SetInputMode(_PNH_PARSEINPUT);
    return $output->GetOutput();

}


?>
