<?php
/************************************************************************/
/* SPChat  (Multi Room Web based Chat System)                           */
/* Language file for german language                                    */
/* for phpNUKE Version 5.5 and above (http://www.phpnuke.org)           */
/* and Postnuke Version 7.2.2 and above                 */
/* ==================================================================== */
/* By Frank Wallacher (frank@saarport.net) (c) 2002-2003                */
/* http://www.saarport.net                                              */
/* ==================================================================== */
/* Based on:                                                            */
/* PHPNukeWebChat v2.0                                                  */
/* ===================                                                  */
/* Authors:                                                 */
/*                                  */
/* Frank Wallacher <frank@saarport.dyndns.org                       */
/* Web: http://www.saarport.net                                         */
/*                                  */
/* Oliver Gading   <oliver@gading.de>                   */
/* Web: http://nuke-modules.gading.de                   */
/*                                  */
/* ==================================================================== */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/

if (!eregi('modules.php', $GLOBALS['HTTP_SERVER_VARS']['PHP_SELF'])) die ("You can't access this file directly...");

$GLOBALS['spchat']['ModDir'] = $GLOBALS[name];
require_once('mainfile.php');

get_lang($GLOBALS['spchat']['ModDir']);

include_once('modules/'.$GLOBALS['spchat']['ModDir'].'/inc/init.inc.php');
include(_SPCHAT_INCLUDEPATH.'inc/functions.php');
include('header.php');

/* ------------------------------------------------------------------- */

function spchat_setup_show_license() {

    $tpl_title_license = _LICENSE_HEAD;

    ob_start();
    if(file_exists($GLOBALS['spchat']['basedir'].'/docs/LICENSE_'.spchat_sys_currentlang().'.txt'))
        include($GLOBALS['spchat']['basedir'].'/docs/LICENSE_'.spchat_sys_currentlang().'.txt');
    else
        include($GLOBALS['spchat']['basedir'].'/docs/LICENSE_english.txt');
    $tpl_license = ob_get_contents();
    ob_end_clean();

    include(_SPCHAT_INCLUDEPATH.'inc/tplinit.inc.php');

    // Output
    include($GLOBALS['spchat']['templatedir'].'/setup_header.tpl');
    include($GLOBALS['spchat']['templatedir'].'/setup_license.tpl');
    include($GLOBALS['spchat']['templatedir'].'/user_footer.tpl');

}

function spchat_setup_install() {
    include_once(_SPCHAT_INCLUDEPATH.'inc/dbsetup.inc.php');

    $status = spchat_db_init();
    if ($status === false)
        spchat_db_delete();

    $tpl_title_install = 'Install';
    $tpl_install_status = $status;

    $tpl_successful = _INSTALL_SUCCESSFUL;
    $tpl_failed = _INSTALL_FAILED;

    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();

    include(_SPCHAT_INCLUDEPATH.'inc/tplinit.inc.php');


    // Output
    include($GLOBALS['spchat']['templatedir'].'/setup_header.tpl');
    include($GLOBALS['spchat']['templatedir'].'/setup_install.tpl');
    include($GLOBALS['spchat']['templatedir'].'/user_footer.tpl');

}

function spchat_setup_update() {
    include_once(_SPCHAT_INCLUDEPATH.'inc/dbsetup.inc.php');

    $spchat_oldversion = $GLOBALS['spchat']['config']['pversion'] .'.'.$GLOBALS['spchat']['config']['subversion'];

    $status = spchat_db_upgrade($spchat_oldversion);

    $tpl_title_update = 'Update';
    $tpl_update_status = $status;

    $tpl_successful = _UPGRADE_SUCCESSFUL;
    $tpl_failed = _UPGRADE_FAILED;

    spchat_sys_getsysconfig();
    spchat_sys_getchatconfig();

    include(_SPCHAT_INCLUDEPATH.'inc/tplinit.inc.php');


    // Output
    include($GLOBALS['spchat']['templatedir'].'/setup_header.tpl');
    include($GLOBALS['spchat']['templatedir'].'/setup_update.tpl');
    include($GLOBALS['spchat']['templatedir'].'/user_footer.tpl');

}

function spchat_setup_check_sys() {
    global $prefix,$dbconn;

    $tpl_title_checksys = _SYSTEMTEST;

    // Checking Nuke System Type
#    $dbconn->debug=true;
    $check_result = $dbconn->Execute("SELECT radminsuper FROM ".$prefix."_authors");
    if($check_result->EOF) {
        $NukeType="unknown";
    } else {
        $NukeType="PHPNuke kompatibel";
        if($Version_Num) {
            if($Version_Num > 5.5) {
                $Nuke_Version .= ' too old!';
            } else {
                $nuke=_STANDARD;
            }

        } else {
            global $Version_Num;
            if($Version_Num > '5.5') {
                $Nuke_Version .= ' too old!';
            } else {
                $nuke=_DATENBANK;
            }

        }
    }
    $check_result->Close();


    /*SHOW DATAS AND SETTINGS */
    $tpl_sysresult = _SYS_RESULT;


    list($status_do_upgrade,$status_do_upgrade_message) = spchat_setup_check_doupgrade();
    if($GLOBALS['spchat']['configfound'] === false) {
        $tpl_setup_method = 'install';
        $tpl_setup_method_descr = _NEWINSTALL;
        $tpl_setup_method_button = _SPCHAT_BUTTON_INSTALL;
    } elseif ($status_do_upgrade === true) {
        $tpl_setup_method = 'spupdate';
        $tpl_setup_method_descr = _SPUPDATE;
        $tpl_setup_method_button = _SPCHAT_BUTTON_SPUPDATE;
    } elseif (!empty($tpl_error_message)) {
        $tpl_setup_method = 'none';
        $tpl_setup_method_descr = _INSTALLERROR;
    } else {
        $tpl_setup_method = 'none';
        $tpl_setup_method_descr = _VERSIONSEQUAL;
    }


    $tpl_nuke = $nuke;
    $tpl_permtest = _PERMTEST;
    $tpl_perms_ok = _PERMS_OK;

    $tpl_OLDVERSION = _OLDVERSION;
    $tpl_NEWVERSION = _NEWVERSION;

    if($nuke == "standard") {
            print '<td>'._PERMTEST.':</td><td>';
            if($write == 1) {
                print _PERMS_OK.'</td></tr>';
            }
    }
    
    list($dbconn) = spchat_db_getdbconn();
    $pntable = spchat_db_gettables();
    $authors_table = $pntable['authors'];
    $authors_column = &$pntable['authors_column'];
    $users_table = $pntable['users'];
    $users_column = &$pntable['users_column'];
    
    if(is_user($GLOBALS[user])) {
        $myuid = spchat_sys_get_uid();
                
            $sql = "SELECT $users_column[uname],$users_column[uid] 
          FROM ($users_table  LEFT JOIN $authors_table ON ($users_column[uname] = $authors_column[aid])) 
         WHERE $users_column[uid] = $myuid AND $authors_column[radminsuper] = 1
             "; 
        
       // $dbconn->debug=true;
            $result = $dbconn->Execute($sql);
            if(!$result->EOF) {
            list($tpl_admin_name,$tpl_admin_uid) = $result->fields;
        $tpl_admin_enter = 1;
            } else {
            $tpl_admin_enter = 0;
        }
       } else {
            $tpl_admin_enter = 0;
       }
    
    include(_SPCHAT_INCLUDEPATH.'inc/tplinit.inc.php');
    
    

    // Output
    include($GLOBALS['spchat']['templatedir'].'/setup_header.tpl');
    include($GLOBALS['spchat']['templatedir'].'/setup_checksys.tpl');
    include($GLOBALS['spchat']['templatedir'].'/user_footer.tpl');

}



/* ------------------------------------------------------------------- */

if (spchat_auth_isadmin())
{
    switch($action){

        case 'agree':
            spchat_setup_check_sys();
            break;

        case 'install':
            if (!isset($GLOBALS['admin_uid']))
                $GLOBALS['admin_uid'] = $myuid;
            spchat_setup_install();
            break;

        case 'spupdate':
            $oldversion = spchat_sys_getchatoldversion();
            spchat_setup_update($oldversion);
            break;

        default:
            spchat_setup_show_license();
    }
}

include ('footer.php');
?>
